Subject: Re: [MIB-DOCTORS] Heads-up MIB review impending

From: Thomas Nadeau <[email-masked]>
Date: Wed, 6 Jun 2012 21:22:20 -0400

Hi all,

Here are my MIB Doctor review comments on the draft-ietf-manet-nhdp-mib-13 MIB.

This document is clearly written and the examples are well done.

My review is divided into two sections: General Comments, and specific comments inline starting with TOM:

General Comments
----------------

 1.  I did not re-compile the MIB as I am assuming Bert's comments from compilation were sufficient.  These comments are IN ADDITION to Bert's so please make fixes required from his comments too.

2. Please go through the objects in the module and look for uses of DISPLAY-STRING and UNITS where possible. There are numerous cases where it should have been used but wasn't. I did not point out every one, just the first one.

3. In general, you have not explicitly described what happens to rows in the tables where read-create objects exist. You must describe these behaviors. I have noted the first instance of this, but please check all tables.

4. The use of DisplayString in the MIB is quite prevalent. RFC4181 is very clear in stating that:

   Note 2.  DisplayString does not support internationalized text.  It
            MUST NOT be used for objects that are required to hold
            internationalized text (which is always the case if the
            object is intended for use by humans [RFC2277]).  Designers
            SHOULD consider using SnmpAdminString, Utf8String, or
            LongUtf8String for such objects.

5. You need a DEFVAL for *every* read-create object. I have noted the first case, but there are LOTS of these in the module that need to be fixed.

6. There is some confusion about your ifTable interaction. You seem to want an EXTENDS relationship, but your modeling is one of AUGMENTS. That is, the index text describes two types of interfaces (without a proper ifType BTW), where you allow for the modeling of non-manet interfaces. What I think you want to do is have this relationship:

ifEntry NhdpInterfaceEntry
1, ifType=mols
2, ifType=mpls
3, ifType=manet    ---------> 3
4, ifType = manet  --------->       4
5, ifType = mpls

That is, you do not have entries in the NhdpInterfaceEntry table for ifIndex-es 1, 2 and 5.

7. I think it is customary to include the full reference description in the REFERENCE clause. For example:

           "RFC 2863 - The Interfaces Group MIB, McCloghrie, K.,
             and F. Kastenholtz, June 2000"

There are a number of these in the document, but I have only noted the first one. Please go through the document and make these corrections, and please do it consistently.

8. When you use InetAddress, you are constraining it to 4 or 16. This is unusual. It is typical to just use the TC as-is.

9.  I have found a number of tables that match this guidance. The easiest thing to do is create a StorageType object in each table and define its semantics.  I have only noted one case of this, but there are a number of them.

There either MUST be one columnar object with a SYNTAX value of
       StorageType [RFC2579] and a MAX-ACCESS value of read-create, or
       else the row object (table entry) DESCRIPTION clause MUST specify
       what happens to dynamically-created rows after an agent restart.

10. In the notifications section, there is ambiguous terminology like "significant number"; you need to define what you expect this means.   In fact, there is a lot of examples for defining explicit MIB variables like nhdpNbrStateChangeThreshold that explicitly define this. This will help aid interoperability.  All of the notifications suffer from this deficiency.

11. The notifications emitted here seem to be potentially of a high volume given that manet applications can include massive numbers of "mobile" devices. You really should include some limiting/throttling parameters as explicit MIB configuration values.  I know that you have defined this in some of the description clauses, but this is not easily interoperable, especially if implementations really need to use smaller values.  Also, the way things are written, it is possible for implementations to experience DoS attack on the device because it is forced to emit so many notifications that it overwhelms the CPU. The "bad packets" notification is a great example.

12. The  nhdpIfState notification is potentially dangerous given how the IfTable relationship is currently defined above to be essentially a 1:1 match with the IfEntry.  Imagine having to issue notifications constantly for IF state changes for every interface in the normal IF-MIB and then here?  Also, what value does this notification add above/beyond the normal IfUp/Down notification if you define an ifType=manet as I suggested above?

13. The  nhdpPacketSrcAddr  notification has no limits or throttling. What if %100 of the packets sent to the device match this criteria? Do you issue a notification for every one?

Internet Engineering Task Force                               U. Herberg
Internet-Draft                                  LIX, Ecole Polytechnique
Intended status: Standards Track                                 R. Cole
Expires: December 3, 2012                                 US Army CERDEC
                                                             I. Chakeres
                                                                  CenGen
                                                            June 1, 2012

 Definition of Managed Objects for the Neighborhood Discovery Protocol
                      draft-ietf-manet-nhdp-mib-14

Abstract

   This document defines a portion of the Management Information Base
   (MIB) for use with network management protocols in the Internet
   community.  In particular, it describes objects for configuring
   parameters of the Neighborhood Discovery Protocol (NHDP) process on a
   router.  The MIB module defined in this memo, denoted NHDP-MIB, also
   reports state, performance information and notifications.  This

TOM: Change the above to:

     "reports state, performance information and notifications about NHDP. This"

   additional state and performance information is useful to
   troubleshoot problems and performance issues during neighbor
   discovery.

Status of This Memo

   This Internet-Draft is submitted in full conformance with the
   provisions of BCP 78 and BCP 79.

   Internet-Drafts are working documents of the Internet Engineering
   Task Force (IETF).  Note that other groups may also distribute
   working documents as Internet-Drafts.  The list of current Internet-
   Drafts is at http://datatracker.ietf.org/drafts/current/.

   Internet-Drafts are draft documents valid for a maximum of six months
   and may be updated, replaced, or obsoleted by other documents at any
   time.  It is inappropriate to use Internet-Drafts as reference
   material or to cite them other than as "work in progress."

   This Internet-Draft will expire on December 3, 2012.

Copyright Notice

   Copyright (c) 2012 IETF Trust and the persons identified as the
   document authors.  All rights reserved.

   This document is subject to BCP 78 and the IETF Trust's Legal
   Provisions Relating to IETF Documents

Herberg, et al.         Expires December 3, 2012                [Page 1]
Internet-Draft                The NHDP-MIB                     June 2012

   (http://trustee.ietf.org/license-info) in effect on the date of
   publication of this document.  Please review these documents
   carefully, as they describe your rights and restrictions with respect
   to this document.  Code Components extracted from this document must
   include Simplified BSD License text as described in Section 4.e of
   the Trust Legal Provisions and are provided without warranty as
   described in the Simplified BSD License.

Table of Contents

   1.  Introduction . . . . . . . . . . . . . . . . . . . . . . . . .  3
   2.  The Internet-Standard Management Framework . . . . . . . . . .  3
   3.  Conventions  . . . . . . . . . . . . . . . . . . . . . . . . .  3
   4.  Overview . . . . . . . . . . . . . . . . . . . . . . . . . . .  3
     4.1.  Terms  . . . . . . . . . . . . . . . . . . . . . . . . . .  3
   5.  Structure of the MIB Module  . . . . . . . . . . . . . . . . .  4
     5.1.  Notifications  . . . . . . . . . . . . . . . . . . . . . .  4
       5.1.1.  Introduction . . . . . . . . . . . . . . . . . . . . .  4
       5.1.2.  Notification Generation  . . . . . . . . . . . . . . .  5
       5.1.3.  Limiting Frequency of Notifications  . . . . . . . . .  5
     5.2.  The Configuration Group  . . . . . . . . . . . . . . . . .  6
     5.3.  The State Group  . . . . . . . . . . . . . . . . . . . . .  6
     5.4.  The Performance Group  . . . . . . . . . . . . . . . . . .  7
     5.5.  Tables and Indexing  . . . . . . . . . . . . . . . . . . .  7
   6.  Relationship to Other MIB Modules  . . . . . . . . . . . . . .  9
     6.1.  Relationship to the SNMPv2-MIB . . . . . . . . . . . . . .  9
     6.2.  Relationship to Routing Protocol MIB Modules Relying
           on the NHDP-MIB Module . . . . . . . . . . . . . . . . . .  9
     6.3.  MIB Modules Required for IMPORTS . . . . . . . . . . . . . 10
   7.  Definitions  . . . . . . . . . . . . . . . . . . . . . . . . . 10
   8.  Security Considerations  . . . . . . . . . . . . . . . . . . . 59
   9.  IANA Considerations  . . . . . . . . . . . . . . . . . . . . . 61
   10. Acknowledgements . . . . . . . . . . . . . . . . . . . . . . . 61
   11. References . . . . . . . . . . . . . . . . . . . . . . . . . . 61
     11.1. Normative References . . . . . . . . . . . . . . . . . . . 61
     11.2. Informative References . . . . . . . . . . . . . . . . . . 62
   Appendix A.    . . . . . . . . . . . . . . . . . . . . . . . . . . 63

Herberg, et al.         Expires December 3, 2012                [Page 2]
Internet-Draft                The NHDP-MIB                     June 2012

1.  Introduction

   This document defines a portion of the Management Information Base
   (MIB) for use with network management protocols in the Internet
   community.  In particular, it describes objects for configuring
   parameters of the Neighborhood Discovery Protocol [RFC6130] process
   on a router.  The MIB module defined in this memo, denoted NHDP-MIB,
   also reports state, performance information and notifications.  This
   additional state and performance information is useful to
   troubleshoot problems and performance issues during neighbor
   discovery.

2.  The Internet-Standard Management Framework

   For a detailed overview of the documents that describe the current
   Internet-Standard Management Framework, please refer to Section 7 of
   [RFC3410].

   Managed objects are accessed via a virtual information store, termed
   the Management Information Base or MIB.  MIB objects are generally
   accessed through the Simple Network Management Protocol (SNMP).
   Objects in the MIB module are defined using the mechanisms defined in
   the Structure of Management Information (SMI).  This memo specifies a
   MIB module that is compliant to the SMIv2, which is described in
   [RFC2578], [RFC2579] and [RFC2580].

3.  Conventions

   The key words "MUST", "MUST NOT", "REQUIRED", "SHALL", "SHALL NOT",
   "SHOULD", "SHOULD NOT", "RECOMMENDED", "NOT RECOMMENDED", "MAY", and
   OPTIONAL" in this document are to be interpreted as described in
   [RFC2119].

4.  Overview

   [RFC6130] allows a router in a Mobile Ad Hoc Network (MANET) to
   discover and track topological information of routers up to two hops
   away by virtue of exchanging HELLO messages.  This information is
   useful for routers running various routing and multicast flooding
   protocols developed within the IETF MANET Working Group.

4.1.  Terms

   The following definitions apply throughout this document:

   o  Notification Objects - triggers and associated notification
      messages allowing for asynchronous tracking of pre-defined events
      on the managed router.

Herberg, et al.         Expires December 3, 2012                [Page 3]
Internet-Draft                The NHDP-MIB                     June 2012

   o  Configuration Objects - switches, tables, objects which are
      initialized to default settings or set through the management
      interface defined by this MIB module.

   o  State Objects - automatically generated values which define the
      current operating state of the NHDP protocol process in the
      router.

   o  Performance Objects - automatically generated values which help an
      administrator or automated tool to assess the performance of the
      NHDP protocol process on the router and the overall discovery
      performance within the MANET.

5.  Structure of the MIB Module

   This section presents the structure of the NHDP-MIB module.  The MIB
   module is arranged into the following structure:

   o  nhdpNotifications - objects defining NHDP-MIB notifications.

   o  nhdpObjects - defining objects within this MIB module.  The
      objects are arranged into the following groups:

      *  Configuration Group - defining objects related to the
         configuration of the NHDP instance on the router.

      *  State Group - defining objects which reflect the current state
         of the NHDP instance running on the router.

      *  Performance Group - defining objects which are useful to a
         management station when characterizing the performance of NHDP
         on the router and in the MANET.

   o  nhdpConformance - defining the minimal and maximal conformance
      requirements for implementations of this MIB module.

5.1.  Notifications

   This section describes the use of notifications, and mechanisms to
   enhance the ability to manage NHDP networks.

5.1.1.  Introduction

   Notifications can be emitted by an NHDP router as a reaction to a
   specific event.  This allows a network manager to efficiently
   determine the source of problems or significant changes of
   configuration or topology, instead of polling a possibly large number
   of NHDP routers.

Herberg, et al.         Expires December 3, 2012                [Page 4]
Internet-Draft                The NHDP-MIB                     June 2012

5.1.2.  Notification Generation

   When an exception event occurs, the application notifies the local
   agent, which sends a notification to the appropriate SNMP management
   stations.  The message includes the notification type and may include
   a list of notification-specific variables.  Section 7 contains the
   notification definitions, which includes the variable lists.  At
   least one IP address of the NHDP router that originates the
   notification is included in the variable list so that the network
   manager may determine the source of the notification.

5.1.3.  Limiting Frequency of Notifications

   To limit the frequency of notifications, the following additional
   mechanisms are suggested, similar to those in [RFC4750]:

5.1.3.1.  Ignoring Initial Activity

   The majority of critical events occur when NHDP is first enabled on a
   router, at which time the symmetric neighbors and two-hop neighbors
   of the NHDP router are discovered.  During this initial period, a
   potential flood of notifications is unnecessary since the events are
   expected.  To avoid unnecessary notifications, a router SHOULD NOT
   originate expected notifications until a certain time interval has
   elapsed, which is to be predefined by the network manager.  It is
   RECOMMENDED that this time interval is at least 3 x
   'nhdpHelloInterval', so that symmetric neighbors are discovered.  The
   suppression window for notifications is started when the
   'nhdpIfStatus' transitions from its default value of 'false' to
   'true'

5.1.3.2.  Throttling Notifications

   The mechanism for throttling the notifications is the same as in
   [RFC4750] (i.e. the amount of transmitted notifications per time is
   bounded).

   Appropriate values for the window time and upper bound are to be
   selected by the network manager and depend on the deployment of the
   MANET.  If NHDP is deployed on a lossy, wireless medium, sending too
   many notifications in a short time interval may lead to collisions
   and dropped packets.  In particular, in dense deployments of NHDP
   routers (i.e. where each router has many neighbors), a change of the
   local topology may trigger many notifications at the same time.
   [RFC4750] recommends "7 notifications with a window time of 10
   seconds" as upper bound.  As NHDP is expected to be deployed in more

TOM: Change to "as the upper bound."

   lossy channels than OSPF, it is RECOMMENDED to choose a lower
   threshold for the number of notifications per time than that.

Herberg, et al.         Expires December 3, 2012                [Page 5]
Internet-Draft                The NHDP-MIB                     June 2012

   Specifically it is RECOMMENDED to choose a threshold value for the
   objects reflecting the change be set to a value of '10' and have set
   the DEFAULT values for these objects within the Notifications Group
   to this value.  Further, a time window for the change objects is
   defined within this MIB module.  It is RECOMMENDED that if the number
   of occurrences exceeds the change threshold within the previous
   change window, then the notification is to be sent.  Furthermore, it
   is RECOMMENDED that the value for this window be set to at least 5
   times the 'nhdpHelloInterval'.

   The following objects are used to define the thresholds and time
   windows for specific Notifications defined in the NHDP-MIB module:
   'nhdpNbrStateChangeThreshold', 'nhdpNbrStateChangeWindow',
   'nhdp2HopNbrStateChangeThreshold', 'nhdp2HopNbrStateChangeWindow',
   'nhdpIfRxBadPacketThreshold', 'nhdpIfRxBadPacketWindow'.

5.1.3.3.  One Notification per Event

   Similar to the mechanism in [RFC4750], only one notification is sent
   per event.

5.2.  The Configuration Group

   The NHDP router is configured with a set of controls.  The
   authoritative list of configuration controls within the NHDP-MIB
   module are found within the MIB module itself.  Generally, an attempt
   was made in developing the NHDP-MIB module to support all
   configuration objects defined in [RFC6130].  For all of the
   configuration parameters, the same constraints and default values of
   these parameters as defined in [RFC6130] are followed.  Refer to
   [RFC5148] for guidance on setting jitter related parameters, e.g.,
   nhdpMaxJitter.

5.3.  The State Group

   The State Group reports current state information of a router running
   [RFC6130].  The NHDP-MIB State Group tables were designed to contain
   the complete set of state information defined within the information
   bases specified in Section 6, Section 7 and Section 8 of [RFC6130].

   Two constructs, i.e., TEXTUAL CONVENTIONs, are defined to support of
   the tables in the State Group.  The NHDP protocol stores and indexes
   information through sets of (dynamically defined) addresses, i.e.,
   address sets.  Within SMIv2 it is not possible to index tables with
   variably defined address sets.  Hence, these TEXTUAL CONVENTIONS are
   defined to provide a local mapping between NHDP managed address sets
   and SMIv2 table indexing.  These constructs are the NeighborIfIndex
   and NeighborRouterIndex.  These are locally (to the NHDP router)

Herberg, et al.         Expires December 3, 2012                [Page 6]
Internet-Draft                The NHDP-MIB                     June 2012

   defined, unique identifiers of virtual neighbors and neighbor
   interfaces.  Due to the nature of the NHDP protocol, the local router
   may have identified distinct address sets but is not able to
   associate these as a single interface.  Hence, two or more
   NeighborIfIndexes pointing to multiple distinct address sets may in
   fact be related to a common neighbor interface.  This ambiguity may
   also hold with respect to the assignment of the NeighborRouterIndex.
   The local MIB agent is responsible for managing, aggregating and
   retiring the defined indexes, and in updating MIB tables using these
   indexes as the local router learns more about its neighbors'
   topology.  These constructs are used to define indexes to the
   appropriate State Group tables and to correlate table entries to
   address sets, virtual neighbor interfaces and virtual neighbors
   within the MANET.

5.4.  The Performance Group

   The Performance Group reports values relevant to system performance.
   Unstable neighbors or 2-hop neighbors and frequent changes of sets
   can have a negative influence on the performance of NHDP.  This MIB
   module defines several objects that can be polled in order to, e.g.,
   calculate histories or monitor frequencies of changes.  This may help
   the network administrator to determine unusual topology changes or
   other changes that affect stability and reliability of the MANET.
   One such framework is specified in [REPORT-MIB].

5.5.  Tables and Indexing

   The NHDP-MIB module contains a number of tables which record data
   related to:

   o  the local NHDP router,

   o  a local NHDP interface on the NHDP router,

   o  other NHDP routers which are 1-hop removed from the local NHDP
      router,

   o  interfaces on other NHDP routers which are 1-hop removed from the
      local NHDP router, and

   o  other NHDP routers which are 2-hop removed from the local NHDP
      router.

   The NHDP-MIB module's tables are indexed via the following
   constructs:

Herberg, et al.         Expires December 3, 2012                [Page 7]
Internet-Draft                The NHDP-MIB                     June 2012

   o  nhdpIfIndex - which is the IfIndex of the local router on which
      NHDP is enabled.

   o  nhdpDiscIfIndex - a locally managed index representing a known
      interface on an NHDP neighboring router.

   o  nhdpDiscRouterIndex - a locally managed index representing an ID
      of a known neighboring NHDP router.

   These tables and their indexing are:

   o  nhdpInterfaceTable - describes the configuration of the interfaces
      of this NHDP router.  This table has 'INDEX { nhdpIfIndex }'.

   o  nhdpLibLocalIfSetTable - records all network addresses which are
      defined as local interface network addresses on this NHDP router.
      This table has 'INDEX { nhdpLibLocalIfSetIndex }'.

   o  nhdpLibRemovedIfAddrSetTable - records network addresses which
      were recently used as local interface network addresses on this
      NHDP router but have been removed.  This table has 'INDEX {
      nhdpLibRemovedIfAddrSetIndex }'.

   o  nhdpInterfaceStateTable - records state information related to
      specific interfaces of this NHDP router.  This table has 'INDEX {
      nhdpIfIndex }'.

   o  nhdpDiscIfSetTable - include the nhdpDiscRouterIndex of the
      discovered router, the nhdpDiscIfIndex of the discovered interface
      and the current set of addresses associated with this neighbor
      interface.  This table has 'INDEX { nhdpDiscIfSetIndex }'.

   o  nhdpIibLinkSetTable - foreach local interface, this table records
      all links belonging to other routers which are, or recently were,
      1-hop neighbors to this NHDP router.  This table has 'INDEX {
      nhdpIfIndex, nhdpDiscIfIndex }'.

   o  nhdpIib2HopSetTable - foreach local interface, this table records
      network addresses (one at a time) of symmetric 2-hop neighbors,
      and the symmetric links to symmetric 1-hop neighbors of this NHDP
      router through which these symmetric 2-hop neighbors can be
      reached.  This table has 'INDEX { nhdpIfIndex, nhdpDiscIfIndex,
      nhdpIib2HopSetIpAddressType, nhdpIib2HopSetIpAddress }'.

   o  nhdpNibNeighborSetTable - records all network addresses of each
      1-hop neighbor to this NHDP router.  This table has 'INDEX {
      nhdpDiscRouterIndex }'.

Herberg, et al.         Expires December 3, 2012                [Page 8]
Internet-Draft                The NHDP-MIB                     June 2012

   o  nhdpNibLostNeighborSetTable - records network addresses of other
      NHDP routers which recently were symmetric 1-hop neighbors to this
      NHDP router, but which are now advertised as lost.  This table has
      'INDEX { nhdpDiscRouterIndex }'.

   o  nhdpInterfacePerfTable - records performance objects that are
      measured foreach local NHDP interface on this NHDP router.  This
      table has 'INDEX { nhdpIfIndex }'.

   o  nhdpDiscIfSetPerfTable - records performance objects that are
      measured foreach discovered interface of a neighbor of this NHDP
      router.  This table has 'INDEX { nhdpDiscIfIndex }'.

   o  nhdpDiscNeighborSetPerfTable - records performance objects that
      are measured for discovered neighbors of this NHDP router.  This
      table has 'INDEX { nhdpDiscRouterIndex }'.

   o  nhdpIib2HopSetPerfTable - records performance objects that are
      measured for discovered 2-hop neighbors of this NHDP router.  This
      table has 'INDEX { nhdpDiscRouterIndex }'.

6.  Relationship to Other MIB Modules

   This section specifies the relationship of the MIB module contained
   in this document to other standards, particularly to standards
   containing other MIB modules.  Definitions imported from other MIB
   modules and other MIB modules that SHOULD be implemented in
   conjunction with the MIB module contained within this document are
   identified in this section.

6.1.  Relationship to the SNMPv2-MIB

   The 'system' group in the SNMPv2-MIB module [RFC3418] is defined as
   being mandatory for all systems, and the objects apply to the entity
   as a whole.  The 'system' group provides identification of the
   management entity and certain other system-wide data.  The NHDP-MIB
   module does not duplicate those objects.

6.2.  Relationship to Routing Protocol MIB Modules Relying on the NHDP-
      MIB Module

   [RFC6130] allows routing protocols to rely on the neighborhood
   information that is discovered by means of HELLO message exchange.
   In order to allow for troubleshooting, fault isolation, and
   management of such routing protocols through a routing protocol MIB
   module, it may be desired to align the State Group tables of the
   NHDP-MIB module and the routing protocol MIB module.  This is
   accomplished through the definition of two TEXTUAL-CONVENTIONS in the

Herberg, et al.         Expires December 3, 2012                [Page 9]
Internet-Draft                The NHDP-MIB                     June 2012

   NHDP-MIB module: the NeighborIfIndex and the NeighborRouterIndex.
   These object types are used to develop indexes into common NHDP-MIB
   module and routing protocol State Group tables.  These objects are
   locally significant but should be locally common to the NHDP-MIB
   module and the routing protocol MIB module implemented on a common
   networked router.  This will allow for improved cross referencing of
   information across the two MIB modules.

6.3.  MIB Modules Required for IMPORTS

   The following NHDP-MIB module IMPORTS objects from SNMPv2-SMI
   [RFC2578], SNMPv2-TC [RFC2579], SNMPv2-CONF [RFC2580], IF-MIB
   [RFC2863], INET-ADDRESS-MIB [RFC4001], and FLOAT-TC-MIB [RFC6340].

7.  Definitions

   This section contains the MIB module defined by the specification.

NHDP-MIB DEFINITIONS ::= BEGIN

-- This MIB module defines objects for the management of
-- NHDP (RFC6130) - The Neighborhood Discovery Protocol,
-- Clausen, T., Dearlove, C. and J. Dean, January 2011.

IMPORTS

    MODULE-IDENTITY, OBJECT-TYPE, NOTIFICATION-TYPE,
    Counter32, Counter64, Integer32, Unsigned32, mib-2,
                 TimeTicks
                 FROM SNMPv2-SMI  -- RFC2578

    TEXTUAL-CONVENTION, TruthValue, TimeStamp,
                 RowStatus, DisplayString
                 FROM SNMPv2-TC  -- RFC2579

    MODULE-COMPLIANCE, OBJECT-GROUP, NOTIFICATION-GROUP
                 FROM SNMPv2-CONF  -- STD58

    InetAddressType, InetAddress,
    InetAddressPrefixLength
                 FROM INET-ADDRESS-MIB  -- RFC4001

    InterfaceIndex
                 FROM IF-MIB  -- RFC2863

    Float32TC
                 FROM FLOAT-TC-MIB  -- RFC6340
    ;

Herberg, et al.         Expires December 3, 2012               [Page 10]
Internet-Draft                The NHDP-MIB                     June 2012

nhdpMIB MODULE-IDENTITY
       LAST-UPDATED "201206011000Z" -- June 1, 2012
       ORGANIZATION "IETF MANET Working Group"
       CONTACT-INFO
       "WG E-Mail: [email-masked]

        WG Chairs: [email-masked]
                   [email-masked]

        Editors:   Ulrich Herberg
                   Ecole Polytechnique
                   LIX
                   91128 Palaiseau Cedex
                   France
                   [email-masked]
                   http://www.herberg.name/

                   Robert G. Cole
                   US Army CERDEC
                   Space and Terrestrial Communications
                   6010 Frankford Street
                   Bldg 6010, Room 453H
                   Aberdeen Proving Ground, MD 21005
                   USA
                   +1 443 395-8744
                   [email-masked]
                   http://www.cs.jhu.edu/~rgcole/

                   Ian D Chakeres
                   CenGen
                   9250 Bendix Road North
                   Columbia, Maryland  21045
                   USA
                   [email-masked]
                   http://www.ianchak.com/"

       DESCRIPTION
           "This NHDP-MIB module is applicable to routers
            implementing the Neighborhood Discovery Protocol
            defined in RFC6130.

            Copyright (C) The IETF Trust (2012). This version
            of this MIB module is part of RFCXXXX; see the RFC
            itself for full legal notices."

       -- revision
       REVISION "201206011000Z" -- June 1, 2012

Herberg, et al.         Expires December 3, 2012               [Page 11]
Internet-Draft                The NHDP-MIB                     June 2012

       DESCRIPTION
            "The first version of this MIB module,
             published as RFCXXXX.
            "
       -- RFC-Editor assigns XXXX
       ::= { mib-2 XXXX }   -- to be assigned by IANA

--
-- Top-Level Components of this MIB Module
--
nhdpNotifications OBJECT IDENTIFIER ::= { nhdpMIB 0 }
nhdpObjects       OBJECT IDENTIFIER ::= { nhdpMIB 1 }
nhdpConformance   OBJECT IDENTIFIER ::= { nhdpMIB 2 }

--
-- Textual Conventions
--
   -- Two new Textual Conventions have been defined in
   -- this MIB module for indexing into the following
   -- tables and indexing into other tables in other MIB modules.
   -- This was necessary because the NHDP protocol manages and
   -- indexes based upon dynamic address tuples, i.e.,
   -- address sets, while SMI requires statically
   -- defined indexes for accessing its table rows.
   -- The NeighborIfIndex defines a unique (to the local router)
   -- index referencing a discovered virtual interface on another
   -- neighbor within the MANET. The NeighborRouterIndex defines a
   -- unique (to the local router) index referencing a discovered
   -- virtual neighbor within the MANET.
   --
   -- Due to the nature of NHDP,
   -- different indexes may be related to common neighbor
   -- interfaces or common neighbor routers, but the information
   -- obtained through NHDP has not allowed the local router
   -- to relate these virtual objects (i.e., interfaces or routers)
   -- at this point in time.  As more topology information
   -- is gathered by the local router, it may associate
   -- virtual interfaces or routers and collapse these
   -- indexes appropriately.

   -- Multiple addresses can be associated with a
   -- given NeighborIfIndex.  Each NeighborIfIndex is
   -- associated with a NeighborRouterIndex.  Throughout
   -- the nhdpStateObjGroup, the
   -- NeighborIfIndex and the NeighborRouterIndex are used
   -- to define the set of IpAddrs related to a virtual
   -- neighbor interface or virtual neighbor under discussion.

Herberg, et al.         Expires December 3, 2012               [Page 12]
Internet-Draft                The NHDP-MIB                     June 2012

NeighborIfIndex ::= TEXTUAL-CONVENTION
    DISPLAY-HINT "d"
    STATUS       current
    DESCRIPTION
        "An arbitrary, locally unique identifier associated with a
        virtual interface of a discovered NHDP neighbor.
        Due to the nature of NHDP, the local router
        may not know if two distinct addresses belong to the
        same interface of a neighbor or to two different
        interfaces.  As the local router gains more
        knowledge of its neighbors, its local view may change and
        this table will be updated to reflect the local router's current
        understanding associating address sets to neighbor interfaces.
        The local router identifies virtual neighbor interface through

TOM: Change to "...identifies a virtual neighbor"

        the receipt of address lists advertised through an
        NHDP HELLO message.

        All objects of type NeighborIfIndex are assigned by the agent
        out of a common number space.

        The value for each discovered virtual neighbor
        interface may not remain constant from
        one re-initialization of the entity's network management
        agent to the next re-initialization.  If the
        local router gains information associating two virtual
        interfaces on a neighbor as a common interface,
        then the agent must aggregate the two address sets to
        a single index chosen from the set of aggregated indexes,
        it must update all tables in this
        MIB module which are indexed by indexes
        of type NeighborIfIndex.  It can then reuse freed
        index values following the next agent restart.

        The specific value is meaningful only within a given SNMP
        entity."
    SYNTAX       Unsigned32 (1..2147483647)

NeighborRouterIndex ::= TEXTUAL-CONVENTION
    DISPLAY-HINT "d"
    STATUS       current
    DESCRIPTION
        "An arbitrary, locally unique identifier associated with a
        virtual discovered neighbor (one or two hop).  Due to the
        nature of the NHDP protocol, the local router may identify
        multiple virtual neighbors  which in fact are one and
        the same.  Two hop neighbors with more than one advertised

TOM: What is a "two hop neighbor"?  I think you mean "neighbors that are two hops away" or something.

        address will exhibit this behavior.  As the

Herberg, et al.         Expires December 3, 2012               [Page 13]
Internet-Draft                The NHDP-MIB                     June 2012

        local router's knowledge of its neighbors' topology
        increases, the local router will be able to associate
        multiple virtual neighbor indexes into a single virtual
        neighbor index chosen from the set of aggregated indexes,
        it must update all tables in this MIB module indexed by these
        indexes, and it can reuse the freed indexes following the
        next agent re-initialization.

        All objects of type NeighborRouterIndex are assigned by
        the agent out of a common number space.

        The NeighborRouterIndex defines a discovered NHDP peer
        virtual neighbor of the local router.
        The value for each discovered virtual neighbor index must remain
        constant at least from one re-initialization of the entity's
        network management agent to the next re-initialization, except
        that if an application is deleted and re-created.

        The specific value is meaningful only within a given SNMP
        entity. An NeighborRouterIndex value must not be re-used
        until the next agent restart."
    SYNTAX       Unsigned32 (1..2147483647)

--
-- nhdpObjects
--

--    1) Configuration Objects Group
--    2) State Objects Group
--    3) Performance Objects Group

--
-- nhdpConfigurationObjGrp
--

-- Contains the NHDP objects which configure specific options
-- which determine the overall performance and operation of the
-- discovery protocol.

nhdpConfigurationObjGrp OBJECT IDENTIFIER ::= { nhdpObjects 1 }

   nhdpInterfaceTable  OBJECT-TYPE
      SYNTAX      SEQUENCE OF NhdpInterfaceEntry

Herberg, et al.         Expires December 3, 2012               [Page 14]
Internet-Draft                The NHDP-MIB                     June 2012

      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "nhdpInterfaceTable describes the
          configuration of the interfaces of this NHDP router.
          The ifIndex is from the interfaces group
          defined in the Interfaces Group MIB. If the
          corresponding entry with ifIndex value is deleted
          from the Interface Table, then the entry in
          this table is automatically deleted.

          The objects in this table are persistent and when
          written the entity SHOULD save the change to
          non-volatile storage."

TOM: You must describe what happens to rows in this table after an agent restart.

      REFERENCE
         "RFC2863 - The Interfaces Group MIB, McCloghrie,
          K., and F. Kastenholtz, June 2000."
   ::= { nhdpConfigurationObjGrp 1 }

   nhdpInterfaceEntry OBJECT-TYPE
      SYNTAX      NhdpInterfaceEntry
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "nhdpInterfaceEntry describes one NHDP
          local interface configuration as indexed by
          its ifIndex as defined in the Standard MIB II
          Interface Table (RFC2863)."
      INDEX { nhdpIfIndex }
   ::= { nhdpInterfaceTable 1 }

   NhdpInterfaceEntry ::=
      Sequence {
         nhdpIfIndex
            InterfaceIndex,
         nhdpIfName
            DisplayString,
         nhdpIfStatus
            TruthValue,
         nhdpHelloInterval
            Unsigned32,
         nhdpHelloMinInterval
            Unsigned32,
         nhdpRefreshInterval
            Unsigned32,
         nhdpLHoldTime
            Unsigned32,
         nhdpHHoldTime

Herberg, et al.         Expires December 3, 2012               [Page 15]
Internet-Draft                The NHDP-MIB                     June 2012

            Unsigned32,
         nhdpHystAcceptQuality
            Float32TC,
         nhdpHystRejectQuality
            Float32TC,
         nhdpInitialQuality
            Float32TC,
         nhdpInitialPending
            TruthValue,
         nhdpHpMaxJitter
            Unsigned32,
         nhdpHtMaxJitter
            Unsigned32,
         nhdpIfRowStatus
            RowStatus
         }

   nhdpIfIndex  OBJECT-TYPE
      SYNTAX      InterfaceIndex
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "The ifIndex for this interface."
      ::= { nhdpInterfaceEntry 1 }

   nhdpIfName  OBJECT-TYPE
      SYNTAX      DisplayString
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "The textual name of the interface.  The value of this
         object should be the name of the interface as assigned by
         the local device and should be suitable for use in commands
         entered at the device's `console'.  This might be a text
         name, such as `le0' or a simple port number, such as `1',
         depending on the interface naming syntax of the device.

         If there is no local name, or this object is otherwise not
         applicable, then this object contains a zero-length string."
   ::= { nhdpInterfaceEntry 2 }

TOM: You should use something other than DisplayString as per the MIB guidelines.  Please review all DisplayString uses from here on in the module, as I will not repeat this comment.

       Note 2.  DisplayString does not support internationalized text.  It
            MUST NOT be used for objects that are required to hold
            internationalized text (which is always the case if the
            object is intended for use by humans [RFC2277]).  Designers
            SHOULD consider using SnmpAdminString, Utf8String, or
            LongUtf8String for such objects.

TOM: You also need a DEFVAL for *every* read-create object. In this case  DEFVAL {""}

   nhdpIfStatus  OBJECT-TYPE
      SYNTAX      TruthValue
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpIfStatus indicates whether this interface is
          a MANET interface. A value of true(1) indicates

Herberg, et al.         Expires December 3, 2012               [Page 16]
Internet-Draft                The NHDP-MIB                     June 2012

          that the interface is a MANET interface.  A value of
          false(2) indicates that the interface is not a MANET
          interface. This corresponds to the I_manet parameter
          in the Local Interface Set of NHDP.
         "
      DEFVAL { false }
   ::= { nhdpInterfaceEntry 3 }

TOM: Why are you modeling interfaces that are non-MANET interfaces? If you want to do this, you sould use AUGMENT; however, I do not think that you do. I think what you want to do is only have entries here that ARE of type MANET.  In this case you sould define a new IfType for a manet interface so that you can quickly sort through the ifEntries to find MANET interfaces.  To do this, you need to add an IANA entry requesting this new ifType. Ask me if you need help doing this.

   --
   -- Interface Parameters - Message Intervals
   --

   nhdpHelloInterval  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpHelloInterval corresponds to
          HELLO_INTERVAL of NHDP and represents the
          maximum time between the transmission of two
          successive HELLO messages on this MANET interface.

          The following constraint applies to this
          parameter:
             o nhdpHelloInterval >= nhdpHelloMinInterval"
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      DEFVAL { 2000 }
   ::= { nhdpInterfaceEntry 4 }

   nhdpHelloMinInterval  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpHelloMinInterval corresponds to
         HELLO_MIN_INTERVAL of NHDP and represents
         the minimum interval between transmission
         of two successive HELLO messages on this
         MANET interface.

         The following constraint applies to this
         parameter:
             o nhdpHelloInterval >= nhdpHelloMinInterval"

Herberg, et al.         Expires December 3, 2012               [Page 17]
Internet-Draft                The NHDP-MIB                     June 2012

      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      DEFVAL { 500 }
   ::= { nhdpInterfaceEntry 5 }

   nhdpRefreshInterval  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpRefreshInterval corresponds to
         REFRESH_INTERVAL of NHDP and represents the
         maximum interval between advertisements, in
         a HELLO message on this MANET interface, of
         each 1-hop neighbor network address and its
         status.

         The following constraint applies to this
         parameter:
             o nhdpRefreshInterval >= nhdpHelloInterval"
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      DEFVAL { 2000 }
   ::= { nhdpInterfaceEntry 6 }

   --
   -- Interface Parameters - Information Validity times
   --

   nhdpLHoldTime  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpLHoldTime corresponds to
         L_HOLD_TIME of NHDP and represents the period
         of advertisement, on this MANET interface, of
         former 1-hop neighbor network addresses as lost
         in HELLO messages, allowing recipients of these
         HELLO messages to accelerate removal of this
         information from their Link Sets.

         The following constraint applies to this

Herberg, et al.         Expires December 3, 2012               [Page 18]
Internet-Draft                The NHDP-MIB                     June 2012

         parameter:
             o nhdpLHoldTime should be significantly greater
                  than nhdpRefreshInterval"
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      DEFVAL { 6000 }
   ::= { nhdpInterfaceEntry 7 }

   nhdpHHoldTime  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpHHoldTime corresponds to
         H_HOLD_TIME of NHDP and is used as the Value
         in the VALIDITY_TIME Message TLV included in all
         HELLO messages on this MANET interface. It is then
         used by each router receiving such a HELLO message
         to indicate the validity of the information taken
         from that HELLO message and recorded in the receiving
         router's Information Bases.

         The following constraints apply to this
         parameter:
             o nhdpHHoldTime >= nhdpRefreshInterval
             o nhdpHHoldTime should be significantly greater
                  than nhdpRefreshInterval
             o nhdpHHoldTime must be representable as
                  described in RFC5497"
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      DEFVAL { 6000 }
   ::= { nhdpInterfaceEntry 8 }

   --
   -- Interface Parameters - Link Quality
   --

   nhdpHystAcceptQuality  OBJECT-TYPE
      SYNTAX      Float32TC
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpHystAcceptQuality corresponds to
         HYST_ACCEPT of NHDP and represents the link

Herberg, et al.         Expires December 3, 2012               [Page 19]
Internet-Draft                The NHDP-MIB                     June 2012

         quality threshold at or above which a link becomes
         usable, if it was not already so.

         The following constraint applies to this
         parameter:
              o 0 <= nhdpHystRejectQuality
                  <= nhdpHystAcceptQuality <= 1.0"
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      -- DEFVAL { 1.0 }
   ::= { nhdpInterfaceEntry 9 }

   nhdpHystRejectQuality  OBJECT-TYPE
      SYNTAX      Float32TC
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpHystRejectQuality corresponds to
         HYST_REJECT of NHDP and represents the
         link quality threshold below which a
         link becomes unusable, if it was not
         already so.

          The following constraint applies to this
          parameter:
              o 0 <= nhdpHystRejectQuality
                  <= nhdpHystAcceptQuality <= 1.0"
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      -- DEFVAL { 0.0 }
   ::= { nhdpInterfaceEntry 10 }

   nhdpInitialQuality  OBJECT-TYPE
      SYNTAX      Float32TC
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpInitialQuality corresponds to
         INITIAL_QUALITY of NHDP and represents the
         initial quality of a newly identified link.

          The following constraint applies to this
          parameter:
              o 0 <= nhdpInitialQuality <= 1.0"
      REFERENCE
         "Section 5 on Protocol Parameters and

Herberg, et al.         Expires December 3, 2012               [Page 20]
Internet-Draft                The NHDP-MIB                     June 2012

          Constraints of RFC6130."
      -- DEFVAL { 1.0 }
   ::= { nhdpInterfaceEntry 11 }

   nhdpInitialPending  OBJECT-TYPE
      SYNTAX      TruthValue
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpInitialPending corresponds to
         INITIAL_PENDING of NHDP. If true, then a
         newly identified link is considered pending, and
         is not usable until the link quality has reached
         or exceeded the nhdpHystAcceptQuality threshold.

         The following constraints apply to this
         parameter:
             o If nhdpInitialQuality >= nhdpHystAcceptQuality,
               then nhdpInitialPending := false.
             o If nhdpInitialQuality < nhdpHystRejectQuality,
               then nhdpInitialPending := true."
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
   ::= { nhdpInterfaceEntry 12 }

   --
   -- Interface Parameters - Jitter
   --
   nhdpHpMaxJitter  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpHpMaxJitter corresponds to
         HP_MAXJITTER of NHDP and represents the
         value of MAXJITTER used in RFC5148 for
         periodically generated HELLO messages on
         this MANET interface.

         The following constraints apply to this
         parameter:
             o nhdpHpMaxJitter <= nhdpHelloInterval / 2
             o If nhdpHelloInterval > 0, then
               nhdpHpMaxJitter <= nhdpHelloMinInterval
               "
      REFERENCE

Herberg, et al.         Expires December 3, 2012               [Page 21]
Internet-Draft                The NHDP-MIB                     June 2012

         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      DEFVAL { 500 }
   ::= { nhdpInterfaceEntry 13 }

   nhdpHtMaxJitter  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpHtMaxJitter corresponds to
         HT_MAXJITTER of NHDP and represents the
         value of MAXJITTER used in RFC5148 for
         externally triggered HELLO messages on this
         MANET interface.

         The following constraints apply to this
         parameter:
             o nhdpHtMaxJitter <= nhdpHelloInterval / 2
             o If nhdpHelloInterval > 0, then
               nhdpHtMaxJitter <= nhdpHelloMinInterval"
      REFERENCE
         "Section 5 on Protocol Parameters and
          Constraints of RFC6130."
      DEFVAL { 500 }
   ::= { nhdpInterfaceEntry 14 }

   nhdpIfRowStatus  OBJECT-TYPE
      SYNTAX      RowStatus
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "This object permits management of the table
         by facilitating actions such as row creation,
         construction, and destruction. The value of
         this object has no effect on whether other
         objects in this conceptual row can be
         modified.

         An entry may not exist in the active state unless all
         objects in the entry have an appropriate value.

         If this object is not equal to active(1), all associated
         entries in the nhdpLibLocalIfSetTable, nhdpInterfaceStateTable,
         nhdpIibLinkSetTable and the nhdpInterfacePerfTable must be
         deleted."

Herberg, et al.         Expires December 3, 2012               [Page 22]
Internet-Draft                The NHDP-MIB                     June 2012

      REFERENCE
         "RFC6130."
   ::= { nhdpInterfaceEntry 15 }

   --
   -- Router Parameters - Information Validity Time
   --
   nhdpNHoldTime  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-write
      STATUS      current
      DESCRIPTION
         "nhdpNHoldTime corresponds to
         N_HOLD_TIME of NHDP and is used as the period
         during which former 1-hop neighbor network
         addresses are advertised as lost in HELLO
         messages, allowing recipients of these HELLO
         messages to accelerate removal of this information
         from their 2-Hop Sets.

         This object is persistent and when written
         the entity SHOULD save the change to
         non-volatile storage."
      REFERENCE
         "RFC6130.
          Section 5 on Protocol Parameters and
          Constraints."
      DEFVAL { 6000 }
   ::= { nhdpConfigurationObjGrp 2 }

   nhdpIHoldTime  OBJECT-TYPE
      SYNTAX      Unsigned32
      UNITS       "milliseconds"
      MAX-ACCESS  read-write
      STATUS      current
      DESCRIPTION
         "nhdpIHoldTime corresponds to
         I_HOLD_TIME of NHDP and represents the period
         for which a recently used local interface network
         address is recorded.

         This object is persistent and when written
         the entity SHOULD save the change to
         non-volatile storage."
      REFERENCE

Herberg, et al.         Expires December 3, 2012               [Page 23]
Internet-Draft                The NHDP-MIB                     June 2012

         "RFC6130.
          Section 5 on Protocol Parameters and
          Constraints."
      DEFVAL { 6000 }
   ::= { nhdpConfigurationObjGrp 3 }

    -- An NHDP router's Local Information Base (LIB)

    --
    -- Local Interface Set Table
    --

    nhdpLibLocalIfSetTable OBJECT-TYPE
       SYNTAX       SEQUENCE OF NhdpLibLocalIfSetEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
          "A router's Local Interface Set records all
           network addresses which are defined as local
           interface network addresses.  The local interface
           is defined by the nhdpIfIndex.

           The Local Interface Set consists of Local Interface
           Address Tuples per network interface and their prefix
           lengths (in order to determine the network addresses
           related to the interface) and an indication of whether
           the interface is a MANET interface or not.

           Further guidance on the addition or removal of
           local addresses and network addresses is found
           in Section 9 of RFC6130."
       REFERENCE
          "RFC6130."
    ::= { nhdpConfigurationObjGrp 4 }

    nhdpLibLocalIfSetEntry  OBJECT-TYPE
       SYNTAX      NhdpLibLocalIfSetEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "A router's Local Interface Set consists
           of Configured Interface Address Tuples for each network
           interface, and an indication of whether the interface
           is a MANET interface or not.

           (I_local_iface_addr_list, I_manet)
          "

Herberg, et al.         Expires December 3, 2012               [Page 24]
Internet-Draft                The NHDP-MIB                     June 2012

       REFERENCE
          "RFC6130."
       INDEX { nhdpLibLocalIfSetIndex }
    ::= { nhdpLibLocalIfSetTable 1 }

TOM: Why don't you use a second index here and/or extend the ifEntry here?  This table could in the worst case, mimic the ifEntry right?  On some boxes, that could have thousands of entries so you do not want to have multiple copies of this table.

    NhdpLibLocalIfSetEntry ::=
       SEQUENCE {
          nhdpLibLocalIfSetIndex
            Integer32,
          nhdpLibLocalIfSetIfIndex
            InterfaceIndex,
          nhdpLibLocalIfSetIpAddrType
            InetAddressType,
          nhdpLibLocalIfSetIpAddr
            InetAddress,
          nhdpLibLocalIfSetIpAddrPrefixLen
            InetAddressPrefixLength,
          nhdpLibLocalIfSetIsManet
            TruthValue,
          nhdpLibLocalIfSetRowStatus
            RowStatus
         }

   nhdpLibLocalIfSetIndex  OBJECT-TYPE
      SYNTAX      Integer32 (0..65535)
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "The index for this table. Necessary
          because multiple addresses may be associated
          with a given nhdpIfIndex."
      REFERENCE
         "RFC6130."

TOM: I think it is customary to include the full reference description in the REFERENCE clause. For example:

           "RFC 2863 - The Interfaces Group MIB, McCloghrie, K.,
             and F. Kastenholtz, June 2000"

   ::= { nhdpLibLocalIfSetEntry 1 }

   nhdpLibLocalIfSetIfIndex  OBJECT-TYPE
        SYNTAX      InterfaceIndex
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION
           "Specifies the local nhdpIfIndex for which this
            IP address was added."
        REFERENCE
           "RFC6130."
   ::= { nhdpLibLocalIfSetEntry 2 }

   nhdpLibLocalIfSetIpAddrType  OBJECT-TYPE
      SYNTAX      InetAddressType

Herberg, et al.         Expires December 3, 2012               [Page 25]
Internet-Draft                The NHDP-MIB                     June 2012

      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "The type of the nhdpLibLocalIfSetIpAddr
          in the InetAddress MIB (RFC4001).

TOM: You typically use "RFC 4001" (i.e.: with the space between) in the DESCRIPTION clause so that you do not distrupt ID-NITS which will flag this as an unknown reference.

          Only the values ipv4(1) and
          ipv6(2) are supported."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibLocalIfSetEntry 3 }

   nhdpLibLocalIfSetIpAddr  OBJECT-TYPE
      SYNTAX      InetAddress (SIZE(4|16))

TOM: Why are you constraining the InetAddress to 4 or 16? This is uncommon.

      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "nhdpLibLocalIfSetIpAddr is an
          address of an interface of
          this router.

          This object is interpreted according to
          the setting of nhdpLibLocalIfSetIpAddrType."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibLocalIfSetEntry 4 }

   nhdpLibLocalIfSetIpAddrPrefixLen  OBJECT-TYPE
      SYNTAX      InetAddressPrefixLength
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "Indicates the number of leading one bits that
          form the mask. The mask is logically-ANDed
          to the nhdpLibLocalIfSetIpAddr to determine
          the address prefix.  A row match is true
          if the address used as an index falls within
          the network address range defined by the
          address prefix."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibLocalIfSetEntry 5 }

   nhdpLibLocalIfSetIsManet  OBJECT-TYPE
        SYNTAX      TruthValue
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION

Herberg, et al.         Expires December 3, 2012               [Page 26]
Internet-Draft                The NHDP-MIB                     June 2012

           "Specifies whether this interface is
            a MANET interface or not."
        REFERENCE
           "RFC6130."
   ::= { nhdpLibLocalIfSetEntry 6 }

   nhdpLibLocalIfSetRowStatus  OBJECT-TYPE
      SYNTAX      RowStatus
      MAX-ACCESS  read-create
      STATUS      current
      DESCRIPTION
         "This object permits management of the table
         by facilitating actions such as row creation,
         construction, and destruction. The value of
         this object has no effect on whether other
         objects in this conceptual row can be
         modified.

         An entry may not exist in the active state unless all
         objects in the entry have an appropriate value."
      REFERENCE
         "RFC6130."
    ::= { nhdpLibLocalIfSetEntry 7 }

TOM: You need to be more precise in defining the RowStatus objects like this:

           "This variable is used to create, modify, and/or
             delete a row in this table.  When a row in this
             table is in active(1) state, no objects in that row
             can be modified by the agent except
             nhdpLibLocalIfSetRowStatus and
             nhdpLibLocalIfSetStorageType."

TOM:   There either MUST be one columnar object with a SYNTAX value of
       StorageType [RFC2579] and a MAX-ACCESS value of read-create, or
       else the row object (table entry) DESCRIPTION clause MUST specify
       what happens to dynamically-created rows after an agent restart.

    --
    -- Removed Interface Addr Set Table
    --

    nhdpLibRemovedIfAddrSetTable OBJECT-TYPE
       SYNTAX       SEQUENCE OF NhdpLibRemovedIfAddrSetEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
          "A router's Removed Interface Address Set records
          network addresses which were recently used as local
          interface network addresses.  If a router's interface
          network addresses are immutable then the Removed
          Interface Address Set is always empty and may be omitted.
          It consists of Removed Interface Address Tuples, one
          per network address."
       REFERENCE
          "RFC6130."
    ::= { nhdpConfigurationObjGrp 5 }

    nhdpLibRemovedIfAddrSetEntry  OBJECT-TYPE
       SYNTAX      NhdpLibRemovedIfAddrSetEntry
       MAX-ACCESS  not-accessible

Herberg, et al.         Expires December 3, 2012               [Page 27]
Internet-Draft                The NHDP-MIB                     June 2012

       STATUS      current
       DESCRIPTION
          "A router's Removed Interface Address Set consists
          of Removed Interface Address Tuples, one per network
          address:

          (IR_local_iface_addr, IR_time)

          The association between these addrs and
          the router's Interface is found in the
          Standard MIB II's IP address table
          (RFC1213)."
       REFERENCE
          "RFC6130."
       INDEX { nhdpLibRemovedIfAddrSetIndex }
    ::= { nhdpLibRemovedIfAddrSetTable 1 }

    NhdpLibRemovedIfAddrSetEntry ::=
       SEQUENCE {
          nhdpLibRemovedIfAddrSetIndex
            Integer32,
          nhdpLibRemovedIfAddrSetIpAddrType
            InetAddressType,
          nhdpLibRemovedIfAddrSetIpAddr
            InetAddress,
          nhdpLibRemovedIfAddrSetIpAddrPrefixLen
            InetAddressPrefixLength,
          nhdpLibRemovedIfAddrSetIfIndex
            InterfaceIndex,
          nhdpLibRemovedIfAddrSetIRTime
            TimeStamp
         }

   nhdpLibRemovedIfAddrSetIndex  OBJECT-TYPE
      SYNTAX      Integer32 (0..65535)
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "The index for this table. Necessary
          because multiple addresses may be associated
          with a given nhdpIfIndex."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibRemovedIfAddrSetEntry 1 }

   nhdpLibRemovedIfAddrSetIpAddrType  OBJECT-TYPE
      SYNTAX      InetAddressType
      MAX-ACCESS  read-only

Herberg, et al.         Expires December 3, 2012               [Page 28]
Internet-Draft                The NHDP-MIB                     June 2012

      STATUS      current
      DESCRIPTION
         "The type of the nhdpLibRemovedIfAddrSetIpAddr
          in the InetAddress MIB (RFC4001).

          Only the values ipv4(1) and
          ipv6(2) are supported."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibRemovedIfAddrSetEntry 2 }

   nhdpLibRemovedIfAddrSetIpAddr  OBJECT-TYPE
      SYNTAX      InetAddress (SIZE(4|16))
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpLibRemovedIfAddrSetIpAddr is a
          recently used address of an interface of
          this router."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibRemovedIfAddrSetEntry 3 }

   nhdpLibRemovedIfAddrSetIpAddrPrefixLen  OBJECT-TYPE
      SYNTAX      InetAddressPrefixLength
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "Indicates the number of leading one bits that
          form the mask. The mask is logically-ANDed
          to the nhdpLibRemovedIfAddrSetIpAddr to determine
          the address prefix. A row match is true
          if the address used as an index falls within
          the network address range defined by the
          address prefix."
      REFERENCE
         "RFC6130."
   ::= { nhdpLibRemovedIfAddrSetEntry 4 }

     nhdpLibRemovedIfAddrSetIfIndex  OBJECT-TYPE
        SYNTAX      InterfaceIndex
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION
           "Specifies the local IfIndex from which this
            IP address was recently removed."
        REFERENCE

Herberg, et al.         Expires December 3, 2012               [Page 29]
Internet-Draft                The NHDP-MIB                     June 2012

           "RFC6130."
     ::= { nhdpLibRemovedIfAddrSetEntry 5 }

     nhdpLibRemovedIfAddrSetIRTime  OBJECT-TYPE
        SYNTAX      TimeStamp
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION
           "nhdpLibRemovedIfAddrSetIRTime specifies the sysUptime
          when to expire this entry and remove it from the
          'nhdpNibLostNeighborSetTable'"
        REFERENCE
           "RFC6130."
     ::= { nhdpLibRemovedIfAddrSetEntry 6 }

--
-- nhdpStateObjGrp
--

-- Contains information describing the current state of the NHDP
-- process on this router.

nhdpStateObjGrp    OBJECT IDENTIFIER ::= { nhdpObjects 2 }

   nhdpUpTime OBJECT-TYPE
       SYNTAX TimeStamp
        MAX-ACCESS read-only
        STATUS current
        DESCRIPTION
             "The value of sysUpTime at the time current NHDP
              process was initialized.
             "
    ::= { nhdpStateObjGrp 1 }

   nhdpInterfaceStateTable  OBJECT-TYPE
      SYNTAX      SEQUENCE OF NhdpInterfaceStateEntry
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "nhdpInterfaceStateTable lists state information
          related to specific interfaces of this NHDP router.
          The value of nhdpIfIndex is an ifIndex from the
          interfaces group defined in the Interfaces Group
          MIB.

Herberg, et al.         Expires December 3, 2012               [Page 30]
Internet-Draft                The NHDP-MIB                     June 2012

          The objects in this table are persistent and when
          written the entity SHOULD save the change to
          non-volatile storage."
      REFERENCE
         "RFC 2863 - The Interfaces Group MIB, McCloghrie,
          K., and F. Kastenholtz, June 2000."
   ::= { nhdpStateObjGrp 2 }

   nhdpInterfaceStateEntry OBJECT-TYPE
      SYNTAX      NhdpInterfaceStateEntry
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "nhdpInterfaceStateEntry describes one NHDP
          local interface state as indexed by
          its nhdpIfIndex."
      INDEX { nhdpIfIndex }
   ::= { nhdpInterfaceStateTable 1 }

   NhdpInterfaceStateEntry ::=
      SEQUENCE {
         nhdpIfStateUpTime
            TimeStamp
         }

   nhdpIfStateUpTime  OBJECT-TYPE
      SYNTAX      TimeStamp
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
             "The value of the sysUpTime when this
              interface was last initialized as a
              MANET interface."
   ::= { nhdpInterfaceStateEntry 1 }

   --
   -- This table allows for the mapping between discovered
   -- remote interfaces and routers and their addresses.
   --

   nhdpDiscIfSetTable OBJECT-TYPE
      SYNTAX       SEQUENCE OF NhdpDiscIfSetEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
           "A router's set of discovered interfaces on
            neighboring routers."

Herberg, et al.         Expires December 3, 2012               [Page 31]
Internet-Draft                The NHDP-MIB                     June 2012

       REFERENCE
          "RFC6130."
    ::= { nhdpStateObjGrp 3 }

    nhdpDiscIfSetEntry  OBJECT-TYPE
       SYNTAX      NhdpDiscIfSetEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "The entries include the nhdpDiscRouterIndex of
           the discovered router, the nhdpDiscIfIndex
           of the discovered interface and the
           current set of addresses associated
           with this neighbor interface. The
           nhdpDiscIfIndex uniquely identifies
           the remote interface address sets
           through this table. It does not need
           to be unique across the MANET, but must
           be locally unique within this router."
       REFERENCE
          "RFC6130."
       INDEX { nhdpDiscIfSetIndex }
    ::= { nhdpDiscIfSetTable 1 }

    NhdpDiscIfSetEntry ::=
       SEQUENCE {
          nhdpDiscIfSetIndex
            Integer32,
          nhdpDiscIfIndex
            NeighborIfIndex,
          nhdpDiscRouterIndex
            NeighborRouterIndex,
          nhdpDiscIfSetIpAddrType
            InetAddressType,
          nhdpDiscIfSetIpAddr
            InetAddress,
          nhdpDiscIfSetIpAddrPrefixLen
            InetAddressPrefixLength
         }

   nhdpDiscIfSetIndex  OBJECT-TYPE
      SYNTAX      Integer32 (0..65535)
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "The index for this table. Necessary
          because multiple addresses may be associated

Herberg, et al.         Expires December 3, 2012               [Page 32]
Internet-Draft                The NHDP-MIB                     June 2012

          with a given nhdpDiscIfIndex."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetEntry 1 }

   nhdpDiscIfIndex  OBJECT-TYPE
      SYNTAX      NeighborIfIndex
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "The NHDP interface index (locally created)
          of a neighbor's interface.  Used for cross
          indexing into other NHDP tables and other
          MIB modules."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetEntry 2 }

   nhdpDiscRouterIndex  OBJECT-TYPE
      SYNTAX      NeighborRouterIndex
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "The NHDP neighbor index (locally created)
          of a neighboring router.  Used for cross
          indexing into other NHDP tables and other
          MIB modules."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetEntry 3 }

   nhdpDiscIfSetIpAddrType  OBJECT-TYPE
      SYNTAX      InetAddressType
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "The type of the nhdpDiscIfSetIpAddr
          in the InetAddress MIB (RFC4001).

          Only the values ipv4(1) and
          ipv6(2) are supported."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetEntry 4 }

   nhdpDiscIfSetIpAddr  OBJECT-TYPE
      SYNTAX      InetAddress (SIZE(4|16))
      MAX-ACCESS  read-only

Herberg, et al.         Expires December 3, 2012               [Page 33]
Internet-Draft                The NHDP-MIB                     June 2012

      STATUS      current
      DESCRIPTION
         "The nhdpDiscIfSetIpAddr is a
          recently used address of a neighbor
          of this router."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetEntry 5 }

   nhdpDiscIfSetIpAddrPrefixLen  OBJECT-TYPE
      SYNTAX      InetAddressPrefixLength
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "Indicates the number of leading one bits that
          form the mask. The mask is logically-ANDed
          to the nhdpDiscIfSetIpAddr to determine
          the address prefix. A row match is true
          if the address used as an index falls within
          the network address range defined by the
          address prefix."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetEntry 6 }

   -- Interface Information Base (IIB)

   --
   -- Link Set
   --

   nhdpIibLinkSetTable OBJECT-TYPE
      SYNTAX       SEQUENCE OF NhdpIibLinkSetEntry
      MAX-ACCESS   not-accessible
      STATUS       current
      DESCRIPTION
          "A Link Set of an interface records all links
           from other routers which are, or recently
           were, 1-hop neighbors."
      REFERENCE
         "RFC6130."
   ::= { nhdpStateObjGrp 4 }

    nhdpIibLinkSetEntry  OBJECT-TYPE
       SYNTAX      NhdpIibLinkSetEntry
       MAX-ACCESS  not-accessible
       STATUS      current

Herberg, et al.         Expires December 3, 2012               [Page 34]
Internet-Draft                The NHDP-MIB                     June 2012

       DESCRIPTION
          "A Link Set consists of Link Tuples, each
           representing a single link indexed by the
           local and remote interface pair:

           (L_neighbor_iface_addr_list, L_HEARD_time,
            L_SYM_time, L_quality, L_pending,
            L_lost, L_time).

            The local interface is indexed via the
            'nhdpIfIndex'.  The 1-Hop interface is
            indexed via the 'nhdpDiscIfIndex'.  There
            should be an entry in this table for each
            local interface and associated 1-Hop
            neighbor reachable on this local interface.

            Note that L_quality is not included in the
            entries below, because updates may be
            required too frequently."
       REFERENCE
          "RFC6130."
       INDEX { nhdpIfIndex,
               nhdpDiscIfIndex }
    ::= { nhdpIibLinkSetTable 1 }

    NhdpIibLinkSetEntry ::=
       SEQUENCE {
          nhdpIibLinkSetLHeardTime
            TimeStamp,
          nhdpIibLinkSetLSymTime
            TimeStamp,
          nhdpIibLinkSetLPending
            TruthValue,
          nhdpIibLinkSetLLost
            TruthValue,
          nhdpIibLinkSetLTime
            TimeStamp
         }

   nhdpIibLinkSetLHeardTime  OBJECT-TYPE
      SYNTAX      TimeStamp
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpIibLinkSetLHeardTime corresponds
         to L_HEARD_time of NHDP and represents the
         time up to which the MANET interface of the
         1-hop neighbor would be considered heard if

Herberg, et al.         Expires December 3, 2012               [Page 35]
Internet-Draft                The NHDP-MIB                     June 2012

         not considering link quality."
      REFERENCE
         "RFC6130."
   ::= { nhdpIibLinkSetEntry 1 }

   nhdpIibLinkSetLSymTime  OBJECT-TYPE
      SYNTAX      TimeStamp
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpIibLinkSetLSymTime corresponds
         to L_SYM_time of NHDP and represents the time
         up to which the link to the 1-hop neighbor
         would be considered symmetric if not considering
         link quality."
      REFERENCE
         "RFC6130."
   ::= { nhdpIibLinkSetEntry 2 }

   nhdpIibLinkSetLPending  OBJECT-TYPE
      SYNTAX      TruthValue
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpIibLinkSetLPending corresponds
         to L_pending of NHDP and is a boolean flag,
         describing if a link is considered pending
         (i.e., a candidate, but not yet established,
         link)."
      REFERENCE
         "RFC6130."
   ::= { nhdpIibLinkSetEntry 3 }

   nhdpIibLinkSetLLost  OBJECT-TYPE
      SYNTAX      TruthValue
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpIibLinkSetLLost corresponds
         to L_lost of NHDP and is a boolean flag,
         describing if a link is considered lost due
         to low link quality."
      REFERENCE
         "RFC6130."
   ::= { nhdpIibLinkSetEntry 4 }

   nhdpIibLinkSetLTime  OBJECT-TYPE
      SYNTAX      TimeStamp

Herberg, et al.         Expires December 3, 2012               [Page 36]
Internet-Draft                The NHDP-MIB                     June 2012

      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpIibLinkSetLTime specifies the sysUptime
          when to expire this entry and remove it from the
          'nhdpIibLinkSetTable'.
         "
      REFERENCE
         "RFC6130."
   ::= { nhdpIibLinkSetEntry 5 }

  --
  -- 2-Hop Set
  --
    nhdpIib2HopSetTable OBJECT-TYPE
       SYNTAX       SEQUENCE OF NhdpIib2HopSetEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
           "A 2-Hop Set of an interface records network
           addresses of symmetric 2-hop neighbors, and
           the symmetric links to symmetric 1-hop neighbors
           through which these symmetric 2-hop neighbors
           can be reached.  It consists of 2-Hop Tuples."
       REFERENCE
          "RFC6130."
    ::= { nhdpStateObjGrp 5 }

    nhdpIib2HopSetEntry  OBJECT-TYPE
       SYNTAX      NhdpIib2HopSetEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "nhdpIib2HopSetTable consists of 2-Hop Tuples,
           each representing a single network address of
           a symmetric 2-hop neighbor, and a single MANET
           interface of a symmetric 1-hop neighbor.

           (N2_neighbor_iface_addr_list,
            N2_2hop_addr, N2_time).

           The entries include the 2-hop neighbor addresses,
           which act as the table index, and associated
           1-hop symmetric link address set, designated
           through 'nhdpDiscIfIndex', and an expiration time.
           The 'nhdpIfIndex' in the INDEX is
           interface index of the local interface

Herberg, et al.         Expires December 3, 2012               [Page 37]
Internet-Draft                The NHDP-MIB                     June 2012

           through which these 2-hop addresses are
           accessible.  The 'nhdpDiscIfIndex' in the
           INDEX represents the 1-Hop neighbor interface
           through which these 2-Hop addresses are
           reachable."
       REFERENCE
          "RFC6130."
       INDEX { nhdpIfIndex,
               nhdpDiscIfIndex,
               nhdpIib2HopSetIpAddressType,
               nhdpIib2HopSetIpAddress
              }
    ::= { nhdpIib2HopSetTable 1 }

    NhdpIib2HopSetEntry ::=
       SEQUENCE {
          nhdpIib2HopSetIpAddressType
            InetAddressType,
          nhdpIib2HopSetIpAddress
            InetAddress,
          nhdpIib2HopSetIpAddrPrefixLen
            InetAddressPrefixLength,
          nhdpIib2HopSet1HopIfIndex
            NeighborIfIndex,
          nhdpIib2HopSetN2Time
            TimeStamp
         }

   nhdpIib2HopSetIpAddressType  OBJECT-TYPE
      SYNTAX      InetAddressType
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "The type of the nhdpIib2HopSetIpAddress
          in the InetAddress MIB module (RFC4001).

          Only the values ipv4(1) and
          ipv6(2) are supported."
      REFERENCE
         "RFC6130."
   ::= { nhdpIib2HopSetEntry 1 }

   nhdpIib2HopSetIpAddress  OBJECT-TYPE
      SYNTAX      InetAddress (SIZE(4|16))
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "nhdpIib2HopSetIpAddr corresponds

Herberg, et al.         Expires December 3, 2012               [Page 38]
Internet-Draft                The NHDP-MIB                     June 2012

         to N2_2hop_addr of NHDP and is a network
         address of a symmetric 2-hop neighbor that
         has a symmetric link (using any MANET
         interface) to the indicated symmetric
         1-hop neighbor."
      REFERENCE
         "RFC6130."
   ::= { nhdpIib2HopSetEntry 2 }

   nhdpIib2HopSetIpAddrPrefixLen  OBJECT-TYPE
      SYNTAX      InetAddressPrefixLength
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "Indicates the number of leading one bits that
          form the mask. The mask is logically-ANDed
          to the nhdpIib2HopSetIpAddress to determine
          the address prefix. A row match is true
          if the address used as an index falls within
          the network address range defined by the
          address prefix."
      REFERENCE
         "RFC6130."
   ::= { nhdpIib2HopSetEntry 3 }

   nhdpIib2HopSet1HopIfIndex  OBJECT-TYPE
      SYNTAX      NeighborIfIndex
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpIib2HopSet1HopIfIndex is
          nhdpDiscIfIndex of the 1-hop
          neighbor which communicated the ipAddress
          of the 2-hop neighbor in this row entry."
      REFERENCE
         "RFC6130."
   ::= { nhdpIib2HopSetEntry 4 }

   nhdpIib2HopSetN2Time  OBJECT-TYPE
      SYNTAX      TimeStamp
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpIib2HopSetN2Time specifies the sysUptime
          when to expire this entry and remove it from the
          'nhdpIib2HopSetTable'."
      REFERENCE
         "RFC6130."

Herberg, et al.         Expires December 3, 2012               [Page 39]
Internet-Draft                The NHDP-MIB                     June 2012

   ::= { nhdpIib2HopSetEntry 5 }

   --
   -- Neighbor Information Base (NIB)
   --
   -- Each router maintains a Neighbor Information Base
   -- that records information about addresses of
   -- current and recently symmetric 1-hop neighbors.

   --
   -- Neighbor Set
   --
   --     The Neighbor Set Table is small because
   --     most of the corresponding information is found
   --     in the nhdpDiscoveredIfTable above.
   --

   nhdpNibNeighborSetTable OBJECT-TYPE
      SYNTAX       SEQUENCE OF NhdpNibNeighborSetEntry
      MAX-ACCESS   not-accessible
      STATUS       current
      DESCRIPTION
          "A router's Neighbor Set records all
           network addresses of each 1-hop
           neighbor."
      REFERENCE
         "RFC6130."
   ::= { nhdpStateObjGrp 6 }

   nhdpNibNeighborSetEntry  OBJECT-TYPE
      SYNTAX      NhdpNibNeighborSetEntry
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
          "A router's Neighbor Set consists
           of Neighbor Tuples, each representing
           a single 1-hop neighbor:

           (N_neighbor_addr_list, N_symmetric)
           "
      REFERENCE
         "RFC6130."
      INDEX { nhdpDiscRouterIndex }
   ::= { nhdpNibNeighborSetTable 1 }

    NhdpNibNeighborSetEntry ::=

Herberg, et al.         Expires December 3, 2012               [Page 40]
Internet-Draft                The NHDP-MIB                     June 2012

       SEQUENCE {
          nhdpNibNeighborSetNSymmetric
            TruthValue
         }

   nhdpNibNeighborSetNSymmetric  OBJECT-TYPE
      SYNTAX      TruthValue
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpNibNeighborNSymmetric corresponds
         to N_symmetric of NHDP and is a boolean flag,
         describing if this is a symmetric 1-hop neighbor."
      REFERENCE
         "RFC6130."
   ::= { nhdpNibNeighborSetEntry 1 }

  --
  -- Lost Neighbor Set
  --
    nhdpNibLostNeighborSetTable OBJECT-TYPE
       SYNTAX       SEQUENCE OF NhdpNibLostNeighborSetEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
           "A router's Lost Neighbor Set records network
           addresses of routers which recently were
           symmetric 1-hop neighbors, but which are now
           advertised as lost."
       REFERENCE
          "RFC6130."
    ::= { nhdpStateObjGrp 7 }

    nhdpNibLostNeighborSetEntry  OBJECT-TYPE
       SYNTAX      NhdpNibLostNeighborSetEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "A router's Lost Neighbor Set consists of
          Lost Neighbor Tuples, each representing a
          single such network address:

          (NL_neighbor_addr, NL_time)"
       REFERENCE
          "RFC6130."
       INDEX { nhdpDiscRouterIndex }
    ::= { nhdpNibLostNeighborSetTable 1 }

Herberg, et al.         Expires December 3, 2012               [Page 41]
Internet-Draft                The NHDP-MIB                     June 2012

    NhdpNibLostNeighborSetEntry ::=
       SEQUENCE {
          nhdpNibLostNeighborSetNLTime
            TimeStamp
         }

   nhdpNibLostNeighborSetNLTime  OBJECT-TYPE
      SYNTAX      TimeStamp
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "nhdpNibLostNeighborSetNLTime
          specifies the sysUptime
          when to expire this entry and remove it from the
          'nhdpNibLostNeighborSetTable'."
      REFERENCE
         "RFC6130."
   ::= { nhdpNibLostNeighborSetEntry 1 }

--
-- nhdpPerformanceObjGrp
--

-- Contains objects which help to characterize the performance of
-- the NHDP process, typically counters.
--
nhdpPerformanceObjGrp OBJECT IDENTIFIER ::= { nhdpObjects 3 }

  --
  -- Objects per local interface
  --

  nhdpInterfacePerfTable  OBJECT-TYPE
      SYNTAX      SEQUENCE OF NhdpInterfacePerfEntry
      MAX-ACCESS  not-accessible
      STATUS      current
      DESCRIPTION
         "This table summarizes performance objects that are
          measured per local NHDP interface."
      REFERENCE
         "RFC6130."
   ::= { nhdpPerformanceObjGrp 1 }

   nhdpInterfacePerfEntry OBJECT-TYPE
      SYNTAX      NhdpInterfacePerfEntry
      MAX-ACCESS  not-accessible

Herberg, et al.         Expires December 3, 2012               [Page 42]
Internet-Draft                The NHDP-MIB                     June 2012

      STATUS      current
      DESCRIPTION
         "A single entry contains performance counters for
          a local NHDP interface."
      INDEX { nhdpIfIndex }
   ::= { nhdpInterfacePerfTable 1 }

   NhdpInterfacePerfEntry ::=
      SEQUENCE {
         nhdpIfHelloMessageXmits
            Counter32,
         nhdpIfHelloMessageRecvd
            Counter32,
         nhdpIfHelloMessageXmitAccumulatedSize
            Counter64,
         nhdpIfHelloMessageRecvdAccumulatedSize
            Counter64,
         nhdpIfHelloMessageTriggeredXmits
            Counter32,
         nhdpIfHelloMessagePeriodicXmits
            Counter32,
         nhdpIfHelloMessageXmitAccumulatedSymmetricNeighborCount
            Counter32,
         nhdpIfHelloMessageXmitAccumulatedHeardNeighborCount
            Counter32,
         nhdpIfHelloMessageXmitAccumulatedLostNeighborCount
            Counter32
         }

   nhdpIfHelloMessageXmits  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented each time a HELLO
         message has been transmitted on that interface."
   ::= { nhdpInterfacePerfEntry 1 }

   nhdpIfHelloMessageRecvd  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented each time a
         HELLO message has been received on that interface."
   ::= { nhdpInterfacePerfEntry 2 }

   nhdpIfHelloMessageXmitAccumulatedSize  OBJECT-TYPE

Herberg, et al.         Expires December 3, 2012               [Page 43]
Internet-Draft                The NHDP-MIB                     June 2012

      SYNTAX      Counter64
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented by the number of octets in
         a HELLO message each time a
         HELLO message has been sent."
   ::= { nhdpInterfacePerfEntry 3 }

   nhdpIfHelloMessageRecvdAccumulatedSize  OBJECT-TYPE
      SYNTAX      Counter64
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented by the number of octets in
         a HELLO message each time a
         HELLO message has been received."
   ::= { nhdpInterfacePerfEntry 4 }

   nhdpIfHelloMessageTriggeredXmits  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented each time a triggered
         HELLO message has been sent."
   ::= { nhdpInterfacePerfEntry 5 }

   nhdpIfHelloMessagePeriodicXmits  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented each time a periodic
         HELLO message has been sent."
   ::= { nhdpInterfacePerfEntry 6 }

   nhdpIfHelloMessageXmitAccumulatedSymmetricNeighborCount  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented by the number of advertised
         symmetric neighbors in a HELLO each time a HELLO
         message has been sent."
   ::= { nhdpInterfacePerfEntry 7 }

   nhdpIfHelloMessageXmitAccumulatedHeardNeighborCount  OBJECT-TYPE

Herberg, et al.         Expires December 3, 2012               [Page 44]
Internet-Draft                The NHDP-MIB                     June 2012

      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented by the number of advertised
         heard neighbors in a HELLO each time a HELLO
         message has been sent."
   ::= { nhdpInterfacePerfEntry 8 }

   nhdpIfHelloMessageXmitAccumulatedLostNeighborCount  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "A counter is incremented by the number of advertised
         lost neighbors in a HELLO each time a HELLO
         message has been sent."
   ::= { nhdpInterfacePerfEntry 9 }

  --
  -- Objects per discovered neighbor interface
  --
  nhdpDiscIfSetPerfTable OBJECT-TYPE
       SYNTAX       SEQUENCE OF NhdpDiscIfSetPerfEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
          "A router's set of performance properties for
          each discovered interface of a neighbor."
       REFERENCE
          "RFC6130."
   ::= { nhdpPerformanceObjGrp 2 }

   nhdpDiscIfSetPerfEntry  OBJECT-TYPE
       SYNTAX      NhdpDiscIfSetPerfEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "There is an entry for each discovered
          interface of a neighbor."
       REFERENCE
          "RFC6130."
       INDEX { nhdpDiscIfIndex }
   ::= { nhdpDiscIfSetPerfTable 1 }

Herberg, et al.         Expires December 3, 2012               [Page 45]
Internet-Draft                The NHDP-MIB                     June 2012

    NhdpDiscIfSetPerfEntry ::=
       SEQUENCE {
          nhdpDiscIfRecvdPackets
            Counter32,
          nhdpDiscIfExpectedPackets
            Counter32
         }

   nhdpDiscIfRecvdPackets  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This counter increments each
         time this router receives a packet from that interface
         of the neighbor."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetPerfEntry 1 }

   nhdpDiscIfExpectedPackets  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This counter increments by the number
          of missed packets from this neighbor based
          on the packet sequence number each time this
          router receives a packet from that interface
          of the neighbor."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscIfSetPerfEntry 2 }

   --
   -- Objects concerning the neighbor set
   --
   nhdpNibNeighborSetChanges  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This counter increments each time the Neighbor Set changes.
         A change occurs whenever a new Neighbor Tuple has been
         added, a Neighbor Tuple has been removed or any entry of
         a Neighbor Tuple has been modified."

Herberg, et al.         Expires December 3, 2012               [Page 46]
Internet-Draft                The NHDP-MIB                     June 2012

   ::= { nhdpPerformanceObjGrp 3 }

   --
   -- Objects per discovered neighbor
   --
   nhdpDiscNeighborSetPerfTable OBJECT-TYPE
      SYNTAX       SEQUENCE OF NhdpDiscNeighborSetPerfEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
          "A router's set of discovered neighbors and
           their properties."
       REFERENCE
          "RFC6130."
   ::= { nhdpPerformanceObjGrp 4 }

   nhdpDiscNeighborSetPerfEntry  OBJECT-TYPE
       SYNTAX      NhdpDiscNeighborSetPerfEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "The entries include the nhdpDiscRouterIndex of
           the discovered router, as well as performance
           objects related to changes of the Neighbor
           Set."
       REFERENCE
          "RFC6130."
       INDEX { nhdpDiscRouterIndex }
   ::= { nhdpDiscNeighborSetPerfTable 1 }

    NhdpDiscNeighborSetPerfEntry ::=
       SEQUENCE {
          nhdpDiscNeighborNibNeighborSetChanges
            Counter32,
          nhdpDiscNeighborNibNeighborSetUpTime
            TimeStamp,
          nhdpDiscNeighborNibNeighborSetReachableLinkChanges
            Counter32
         }

   nhdpDiscNeighborNibNeighborSetChanges  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This object returns the number of changes

Herberg, et al.         Expires December 3, 2012               [Page 47]
Internet-Draft                The NHDP-MIB                     June 2012

         to the given Neighbor Tuple."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscNeighborSetPerfEntry 1 }

   nhdpDiscNeighborNibNeighborSetUpTime  OBJECT-TYPE
      SYNTAX      TimeStamp
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This object returns the sysUpTime when
         the neighbor becomes 'nbrup'. A neighbor is
         said to become 'nbrup' if a new nhdpNibNeighborSetEntry
         is created for a particular nhdpNibNeighborSetRouterIndex.
         It becomes 'nbrdown' if the entry for that neighbor
         has been deleted."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscNeighborSetPerfEntry 2 }

   nhdpDiscNeighborNibNeighborSetReachableLinkChanges  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This object counts each time the neighbor changes
          the interface(s) over which it is reachable.
          A change in the set of Link Tuples corresponding
          to the appropriate Neighbor Tuple is registered,
          i.e. a corresponding Link Tuple is added or removed
          from the set of all corresponding Link Tuples."
      REFERENCE
         "RFC6130."
   ::= { nhdpDiscNeighborSetPerfEntry 3 }

   --
   -- Objects per discovered 2-hop neighbor
   --
      nhdpIib2HopSetPerfTable OBJECT-TYPE
       SYNTAX       SEQUENCE OF NhdpIib2HopSetPerfEntry
       MAX-ACCESS   not-accessible
       STATUS       current
       DESCRIPTION
           "This table contains performance objects per

Herberg, et al.         Expires December 3, 2012               [Page 48]
Internet-Draft                The NHDP-MIB                     June 2012

           discovered 2-hop neighbor."
       REFERENCE
          "RFC6130."
    ::= { nhdpPerformanceObjGrp 5 }

    nhdpIib2HopSetPerfEntry  OBJECT-TYPE
       SYNTAX      NhdpIib2HopSetPerfEntry
       MAX-ACCESS  not-accessible
       STATUS      current
       DESCRIPTION
          "The entries contain performance objects per
           discovered 2-hop neighbor."
       REFERENCE
          "RFC6130."
       INDEX { nhdpDiscRouterIndex }
    ::= { nhdpIib2HopSetPerfTable 1 }

    NhdpIib2HopSetPerfEntry ::=
       SEQUENCE {
          nhdpIib2HopSetPerfChanges
            Counter32,
          nhdpIib2HopSetPerfUpTime
            TimeStamp
         }

   nhdpIib2HopSetPerfChanges  OBJECT-TYPE
      SYNTAX      Counter32
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This object counts the changes of the union of all
         N2_neighbor_iface_addr_list of 2-Hop Tuples with an
         N2_2hop_addr equal to one of the given 2-hop
         neighbor's addresses."
      REFERENCE
         "RFC6130."
   ::= { nhdpIib2HopSetPerfEntry 1 }

   nhdpIib2HopSetPerfUpTime  OBJECT-TYPE
      SYNTAX      TimeStamp
      MAX-ACCESS  read-only
      STATUS      current
      DESCRIPTION
         "This object returns the sysUpTime
         when the 2-Hop Tuple
         corresponding to the given 2-hop neighbor IP address
         was registered in the nhdpIib2HopSetTable."

Herberg, et al.         Expires December 3, 2012               [Page 49]
Internet-Draft                The NHDP-MIB                     June 2012

      REFERENCE
         "RFC6130."
   ::= { nhdpIib2HopSetPerfEntry 2 }

--
-- nhdpNotifications
--

nhdpNotificationsObjects OBJECT IDENTIFIER ::= { nhdpNotifications 0 }
nhdpNotificationsControl OBJECT IDENTIFIER ::= { nhdpNotifications 1 }
nhdpNotificationsStates  OBJECT IDENTIFIER ::= { nhdpNotifications 2 }

   -- nhdpNotificationsObjects

   nhdpNbrStateChange NOTIFICATION-TYPE
          OBJECTS { nhdpIfName,  -- The originator of
                                  --     the notification.
                    nhdpNbrState  -- The new state
                  }
          STATUS       current
          DESCRIPTION
             "nhdpNbrStateChange is a notification sent when a
             significant number of neighbors change their status
             (i.e. down, asymmetric, or symmetric) in a short
             time. The network administrator should select
             appropriate values for 'significant number of
             neighbors' and 'short time'."
          ::= { nhdpNotificationsObjects 1 }

TOM: You need to provide some guidelines for what "significant number" means.

    nhdp2HopNbrStateChange Notification-TYPE
          OBJECTS { nhdpIfName,      -- The originator
                                      -- of the notification
                    nhdp2HopNbrState  -- The new state
             }
          STATUS       current
          DESCRIPTION
             "nhdp2HopNbrStateChange is a notification sent
             when a significant number of 2-hop neighbors
             change their status (i.e. up or down) in a short
             time. The network administrator should select
             appropriate values for 'significant number of
             neighbors' and 'short time'."
          ::= { nhdpNotificationsObjects 2 }

Herberg, et al.         Expires December 3, 2012               [Page 50]
Internet-Draft                The NHDP-MIB                     June 2012

   nhdpIfRxBadPacket NOTIFICATION-TYPE
          OBJECTS { nhdpDiscRouterIndex, -- The originator of
                                         -- the notification
                    nhdpIfName,          -- The interface on which the
                                         -- packet has been received
                    nhdpPacketSrcAddrType, -- The type of the source IP
                                         -- address of the packet
                    nhdpPacketSrcAddr    -- The source IP address of
                                         -- the packet
             }
          STATUS       current
          DESCRIPTION
             "nhdpIfRxBadPacket is a notification sent when a
             significant number of incoming packets have not
             been successfully parsed in a short time. The
             network administrator should select appropriate
             values for 'significant number of neighbors'
             and 'short time'."
          ::= { nhdpNotificationsObjects 3 }

TOM: I am finding it very difficult to imagine how this would be implemented, and done so in a consistent manner that is interoperable.   Similar to above, you need to either allow the operator to define what "significant" is, or be very clear in what triggers this notification (I prefer the latter).

     Also, I am concerned that there is no throttling of this notification. What if %100 of the packets received are "bad" because the radio link is messed up?  Would this be a DoS attack on the device because it is forced to emit so many notifications that it overwhelms the CPU?

   Nhdpifstatechange NOTIFICATION-TYPE
          OBJECTS { nhdpIfName,  -- The local interface
                    nhdpIfState  -- The new state
             }
          STATUS       current
          DESCRIPTION
             "nhdpIfStateChange is a notification sent when
             the status of an interface of this router has
             changed (i.e. an IP address has been added or
             removed to the interface, or the interface has
             changed its status from up to down or vice versa)."
          ::= { nhdpNotificationsObjects 4 }

   -- nhdpNotificationsControl

   nhdpNbrStateChangeThreshold OBJECT-TYPE
          SYNTAX       Integer32 (0..255)
          MAX-ACCESS   read-write
          STATUS       current
          DESCRIPTION
             "A threshold value for the
              nhdpNbrStateChange object. If the
              number of occurrences exceeds this threshold
              within the previous nhdpNbrStateChangeWindow,

Herberg, et al.         Expires December 3, 2012               [Page 51]
Internet-Draft                The NHDP-MIB                     June 2012

              then the nhdpNbrStateChange notification
              is to be sent.

              It is recommended that the value of this
              threshold be set to at least 10, and higher
              in dense topologies with frequent expected
              topology changes.
             "
          DEFVAL { 10 }
          ::= { nhdpNotificationsControl 1 }

   nhdpNbrStateChangeWindow OBJECT-TYPE
          SYNTAX       TimeTicks
          MAX-ACCESS   read-write
          STATUS       current
          DESCRIPTION
             "A time window for the
              nhdpNbrStateChange object. If the
              number of occurrences exceeds the
              nhdpNbrStateChangeThreshold
              within the previous nhdpNbrStateChangeWindow,
              then the nhdpNbrStateChange notification
              is to be sent.

              It is recommended that the value for this
              window be set to at least 5 times the
              nhdpHelloInterval.

              This object represents the time in hundredths
              of a second.
             "
          DEFVAL { 1000 }
          ::= { nhdpNotificationsControl 2 }

   nhdp2HopNbrStateChangeThreshold OBJECT-TYPE
          SYNTAX       Integer32 (0..255)
          MAX-ACCESS   read-write
          STATUS       current
          DESCRIPTION
             "A threshold value for the
              nhdp2HopNbrStateChange object. If the
              number of occurrences exceeds this threshold
              within the previous nhdp2HopNbrStateChangeWindow,
              then the nhdp2HopNbrStateChange notification
              is to be sent.

              It is recommended that the value of this
              threshold be set to at least 10, and higher

Herberg, et al.         Expires December 3, 2012               [Page 52]
Internet-Draft                The NHDP-MIB                     June 2012

              when topologies are expected to be highly dynamic.
             "
          DEFVAL { 10 }
          ::= { nhdpNotificationsControl 3 }

   nhdp2HopNbrStateChangeWindow OBJECT-TYPE
          SYNTAX       TimeTicks
          MAX-ACCESS   read-write
          STATUS       current
          DESCRIPTION
             "A time window for the
              nhdp2HopNbrStateChange object. If the
              number of occurrences exceeds the
              nhdp2HopNbrStateChangeThreshold
              within the previous nhdp2HopNbrStateChangeWindow,
              then the nhdp2HopNbrStateChange notification
              is to be sent.

              It is recommended that the value for this
              window be set to at least 5 times
              nhdpHelloInterval.

              This object represents the time in hundredths
              of a second.
             "
          DEFVAL { 1000 }
          ::= { nhdpNotificationsControl 4 }

   nhdpIfRxBadPacketThreshold OBJECT-TYPE
          SYNTAX       Integer32 (0..255)
          MAX-ACCESS   read-write
          STATUS       current
          DESCRIPTION
             "A threshold value for the
              nhdpIfRxBadPacket object. If the
              number of occurrences exceeds this threshold
              within the previous nhdpIfRxBadPacketWindow,
              then the nhdpIfRxBadPacket notification
              is to be sent.
             "
          DEFVAL { 10 }
          ::= { nhdpNotificationsControl 5 }

   nhdpIfRxBadPacketWindow OBJECT-TYPE
          SYNTAX       TimeTicks
          MAX-ACCESS   read-write
          STATUS       current
          DESCRIPTION

Herberg, et al.         Expires December 3, 2012               [Page 53]
Internet-Draft                The NHDP-MIB                     June 2012

             "A time window for the
              nhdpIfRxBadPacket object. If the
              number of occurrences exceeds the
              nhdpIfRxBadPacketThreshold
              within the previous nhdpIfRxBadPacketWindow,
              then the nhdpIfRxBadPacket notification
              is to be sent.

              It is recommended that the value for this
              window be set to 5 times the nhdpHelloInterval.

              This object represents the time in hundredths
              of a second.
             "
          DEFVAL { 1000 }
          ::= { nhdpNotificationsControl 6 }

    -- nhdpNotificationStates

    nhdpNbrState OBJECT-TYPE
       SYNTAX       INTEGER {
                       down(0),
                       asymmetric(1),
                       symmetric(2)
                       }
       MAX-ACCESS   read-only
       STATUS       current
       DESCRIPTION
          "NHDP neighbor states. In NHDP it is not
           necessary to remove Protocol Tuples from Protocol Sets
           at the exact time indicated, only to behave as if the
           Protocol Tuples were removed at that time. This case is
           indicated here as 'down(0)', all other cases being
           indicated as 'assymetric(1)' or 'symmetric(2)'. If down,
           the direct neighbor is also added to the
           nhdpNibLostNeighborSetTable.
           "
       ::= { nhdpNotificationsStates 1 }

   nhdp2HopNbrState OBJECT-TYPE
       SYNTAX       INTEGER {
                       down(0),
                       up(1)
                       }
       MAX-ACCESS   read-only
       STATUS       current

Herberg, et al.         Expires December 3, 2012               [Page 54]
Internet-Draft                The NHDP-MIB                     June 2012

       DESCRIPTION
          "NHDP 2-hop neighbor states.  In NHDP it is not
           necessary to remove Protocol Tuples from Protocol Sets
           at the exact time indicated, only to behave as if the
           Protocol Tuples were removed at that time. This case is
           indicated here as 'down(0)', otherwise as 'up(1)'."
       ::= { nhdpNotificationsStates 2 }

   Nhdpifstate Object-TYPE
       SYNTAX       TruthValue
       MAX-ACCESS   read-only
       STATUS       current
       DESCRIPTION
          "NHDP MANET interface states. This indicates whether
           the interface is a MANET interface. A value of true(1)
           indicates that the interface is a MANET interface.
           A value of false(2) indicates that the interface is
           not a MANET interface. This corresponds to the I_manet
           parameter in the Local Interface Set."
       ::= { nhdpNotificationsStates 3 }

TOM: This notification is potentially dangerous given how the IfTable relationship is currently defined above to be essentially a 1:1 match with the IfEntry.  Imagine having to issue notifications constantly for IF state changes for every interface in the normal IF-MIB and then here?  Also, what value does this notification add above/beyond the normal IfUp/Down notification if you define an ifType=manet as I suggested above?

  nhdpPacketSrcAddrType OBJECT-TYPE
           SYNTAX InetAddressType
           MAX-ACCESS read-only
           STATUS current
           DESCRIPTION
           "The IP address type of the
           address of an inbound packet that
           cannot be identified by a neighbor instance.

           Only the values ipv4(1) and ipv6(2) are supported.
           "
          ::= { nhdpNotificationsStates 4 }

   nhdpPacketSrcAddr Object-TYPE
          SYNTAX InetAddress (SIZE(4|16))
          MAX-ACCESS   read-only
          STATUS       current
          DESCRIPTION
             "The IP address of an inbound packet that
             cannot be identified by a neighbor instance. When
             the last value of a notification using this object is
             needed, but no notifications of that type have been sent,
             the value pertaining to this object should
             be returned as 0.0.0.0 or :: respectively.
             "
          ::= { nhdpNotificationsStates 5 }

Herberg, et al.         Expires December 3, 2012               [Page 55]
Internet-Draft                The NHDP-MIB                     June 2012

--
-- nhdpConformance information
--

nhdpCompliances       OBJECT IDENTIFIER ::= { nhdpConformance 1 }
nhdpMIBGroups         OBJECT IDENTIFIER ::= { nhdpConformance 2 }

-- Compliance Statements
nhdpBasicCompliance MODULE-COMPLIANCE
  STATUS current
  DESCRIPTION
    "The basic implementation requirements for
     managed network entities that implement
     NHDP."
  MODULE -- this module

  MANDATORY-GROUPS { nhdpConfigurationGroup }
  ::= { nhdpCompliances 1 }

nhdpFullCompliance MODULE-COMPLIANCE
  STATUS current
  DESCRIPTION
    "The full implementation requirements for
     managed network entities that implement
     NHDP."
  MODULE -- this module

  MANDATORY-GROUPS { nhdpConfigurationGroup,
                     nhdpStateGroup,
                     nhdpNotificationObjectGroup,
                     nhdpNotificationGroup,
                     nhdpPerformanceGroup }
  ::= { nhdpCompliances 2 }

--
-- Units of Conformance
--

  nhdpConfigurationGroup OBJECT-GROUP
     OBJECTS {
              nhdpIfName,
              nhdpIfStatus,
              nhdpHelloInterval,
              nhdpHelloMinInterval,
              nhdpRefreshInterval,

Herberg, et al.         Expires December 3, 2012               [Page 56]
Internet-Draft                The NHDP-MIB                     June 2012

              nhdpLHoldTime,
              nhdpHHoldTime,
              nhdpHystAcceptQuality,
              nhdpHystRejectQuality,
              nhdpInitialQuality,
              nhdpInitialPending,
              nhdpHpMaxJitter,
              nhdpHtMaxJitter,
              nhdpNHoldTime,
              nhdpIHoldTime,
              nhdpIfRowStatus,
              nhdpLibLocalIfSetIfIndex,
              nhdpLibLocalIfSetIpAddrType,
              nhdpLibLocalIfSetIpAddr,
              nhdpLibLocalIfSetIpAddrPrefixLen,
              nhdpLibLocalIfSetIsManet,
              nhdpLibLocalIfSetRowStatus,
              nhdpLibRemovedIfAddrSetIpAddrType,
              nhdpLibRemovedIfAddrSetIpAddr,
              nhdpLibRemovedIfAddrSetIpAddrPrefixLen,
              nhdpLibRemovedIfAddrSetIfIndex,
              nhdpLibRemovedIfAddrSetIRTime
             }
      STATUS  current
      DESCRIPTION
         "Set of NHDP configuration objects implemented
          in this module."
   ::= { nhdpMIBGroups 2 }

  nhdpStateGroup OBJECT-GROUP
     OBJECTS {
              nhdpUpTime,
              nhdpIfStateUpTime,
              nhdpDiscRouterIndex,
              nhdpDiscIfIndex,
              nhdpDiscIfSetIpAddrType,
              nhdpDiscIfSetIpAddr,
              nhdpDiscIfSetIpAddrPrefixLen,
              nhdpIibLinkSetLHeardTime,
              nhdpIibLinkSetLSymTime,
              nhdpIibLinkSetLPending,
              nhdpIibLinkSetLLost,
              nhdpIibLinkSetLTime,
              nhdpIib2HopSetIpAddrPrefixLen,
              nhdpIib2HopSet1HopIfIndex,
              nhdpIib2HopSetN2Time,
              nhdpNibNeighborSetNSymmetric,
              nhdpNibLostNeighborSetNLTime

Herberg, et al.         Expires December 3, 2012               [Page 57]
Internet-Draft                The NHDP-MIB                     June 2012

             }
      STATUS  current
      DESCRIPTION
         "Set of NHDP state objects implemented
          in this module."
   ::= { nhdpMIBGroups 3 }

  nhdpPerformanceGroup OBJECT-GROUP
     OBJECTS {
              nhdpIfHelloMessageXmits,
              nhdpIfHelloMessageRecvd,
              nhdpIfHelloMessageXmitAccumulatedSize,
              nhdpIfHelloMessageRecvdAccumulatedSize,
              nhdpIfHelloMessageTriggeredXmits,
              nhdpIfHelloMessagePeriodicXmits,
              nhdpIfHelloMessageXmitAccumulatedSymmetricNeighborCount,
              nhdpIfHelloMessageXmitAccumulatedHeardNeighborCount,
              nhdpIfHelloMessageXmitAccumulatedLostNeighborCount,
              nhdpDiscIfRecvdPackets,
              nhdpDiscIfExpectedPackets,
              nhdpNibNeighborSetChanges,
              nhdpDiscNeighborNibNeighborSetChanges,
              nhdpDiscNeighborNibNeighborSetUpTime,
              nhdpDiscNeighborNibNeighborSetReachableLinkChanges,
              nhdpIib2HopSetPerfChanges,
              nhdpIib2HopSetPerfUpTime
            }
      STATUS  current
      DESCRIPTION
         "Set of NHDP performance objects implemented
          in this module."
   ::= { nhdpMIBGroups 4 }

    nhdpNotificationObjectGroup OBJECT-GROUP
      OBJECTS {
            nhdpNbrStateChangeThreshold,
            nhdpNbrStateChangeWindow,
            nhdp2HopNbrStateChangeThreshold,
            nhdp2HopNbrStateChangeWindow,
            nhdpIfRxBadPacketThreshold,
            nhdpIfRxBadPacketWindow,
            nhdpIfState,
            nhdpNbrState,
            nhdp2HopNbrState,
            nhdpPacketSrcAddrType,
            nhdpPacketSrcAddr
      }
      STATUS current

Herberg, et al.         Expires December 3, 2012               [Page 58]
Internet-Draft                The NHDP-MIB                     June 2012

      DESCRIPTION
      "Set of NHDP notification objects implemented
      in this module."
   ::= { nhdpMIBGroups 5 }

  nhdpNotificationGroup NOTIFICATION-GROUP
     NOTIFICATIONS {
             nhdpNbrStateChange,
             nhdp2HopNbrStateChange,
             nhdpIfRxBadPacket,
             nhdpIfStateChange
             }
      STATUS  current
      DESCRIPTION
         "Set of NHDP notifications implemented
          in this module."
   ::= { nhdpMIBGroups 6 }

END

8.  Security Considerations

   This MIB module defines objects for the configuration, monitoring and
   notification of the Neighborhood Discovery Protocol [RFC6130].  NHDP
   allows routers to acquire topological information up to two hops away
   by virtue of exchanging HELLO messages.  The information acquired by
   NHDP may be used by routing protocols.  The neighborhood information,
   exchanged between routers using NHDP, serves these routing protocols
   as a baseline for calculating paths to all destinations in the MANET,
   relay set selection for network-wide transmissions etc.

   There are a number of management objects defined in this MIB module
   with a MAX-ACCESS clause of read-write and/or read-create.  Such
   objects may be considered sensitive or vulnerable in some network
   environments.  The support for SET operations in a non-secure
   environment without proper protection can have a negative effect on
   network operations.  These are the tables and objects and their
   sensitivity/vulnerability:

   o  nhdpIfStatus - this writable object turns on or off the NHDP
      process for the specified interface.  If disabled, higher level
      protocol functions, e.g., routing, would fail causing network-wide
      disruptions.

Herberg, et al.         Expires December 3, 2012               [Page 59]
Internet-Draft                The NHDP-MIB                     June 2012

   o  nhdpHelloInterval, nhdpHelloMinInterval, and nhdpRefreshInterval -
      these writable objects control the rate at which HELLO messages
      are sent on an interface.  If set at too high a rate, this could
      represent a form of DOS attack by overloading interface resources.

   o  nhdpHystAcceptQuality, nhdpHystRejectQuality, nhdpInitialQuality,
      nhdpInitialPending - these writable objects affect the perceived
      quality of the NHDP links and hence the overall stability of the
      network.  If improperly set, these settings could result in
      network-wide disruptions.

   o  nhdpInterfaceTable - this table contains writable objects that
      affect the overall performance and stability of the NHDP process.
      Failure of the NHDP process would result in network-wide failure.
      Particularly sensitive objects from this table are discussed in
      the previous list items.  This is the only table in the NHDP-MIB
      module with writable objects.

   Some of the readable objects in this MIB module (i.e., objects with a
   MAX-ACCESS other than not-accessible) may be considered sensitive or
   vulnerable in some network environments.  It is thus important to
   control even GET and/or NOTIFY access to these objects and possibly
   to even encrypt the values of these objects when sending them over
   the network via SNMP.  These are the tables and objects and their
   sensitivity/vulnerability:

   o  nhdpDiscIfSetTable - The object contains information on discovered
      neighbors, specifically their IP address in the
      nhdpDiscIfSetIpAddr object.  This information provides an
      adversary broad information on the members of the MANET, located
      within this single table.  This information can be use to expedite
      attacks on the other members of the MANET without having to go
      through a laborious discovery process on their own.  This object
      is the index into the table, and has a MAX-ACCESS of 'not-
      accessible'.  However, this information can be exposed using SNMP
      operations.

   MANET technology is often deployed to support communications of
   emergency services or military tactical applications.  In these
   applications, it is imperative to maintain the proper operation of
   the communications network and to protect sensitive information
   related to its operation.  Therefore, it is RECOMMENDED to provide
   support for the Transport Security Model (TSM) [RFC5591] in
   combination with TLS/DTLS [RFC6353].

   SNMP versions prior to SNMPv3 did not include adequate security.
   Even if the network itself is secure (for example by using IPsec),
   there is no control as to who on the secure network is allowed to

Herberg, et al.         Expires December 3, 2012               [Page 60]
Internet-Draft                The NHDP-MIB                     June 2012

   access and GET/SET (read/change/create/delete) the objects in this
   MIB module.

   Implementations MUST provide the security features described by the
   SNMPv3 framework (see [RFC3410] ), including full support for
   authentication and privacy via the User-based Security Model (USM)
   [RFC3414] with the AES cipher algorithm [RFC3826].  Implementations
   MAY also provide support for the Transport Security Model (TSM)
   [RFC5591] in combination with a secure transport such as SSH
   [RFC5592] or TLS/DTLS [RFC6353].

   Further, deployment of SNMP versions prior to SNMPv3 is NOT
   RECOMMENDED.  Instead, it is RECOMMENDED to deploy SNMPv3 and to
   enable cryptographic security.  It is then a customer/operator
   responsibility to ensure that the SNMP entity giving access to an
   instance of this MIB module is properly configured to give access to
   the objects only to those principals (users) that have legitimate
   rights to indeed GET or SET (change/create/delete) them.

9.  IANA Considerations

   Editor's Note (to be removed prior to publication): the IANA is
   requested to assign a value for "XXXX" under the 'mib-2' subtree and
   to record the assignment in the SMI Numbers registry.  When the
   assignment has been made, the RFC Editor is asked to replace "XXXX"
   (here and in the MIB module) with the assigned value and to remove
   this note.  Note well: prior to official assignment by the IANA, a
   draft document MUST use placeholders (such as "XXXX" above) rather
   than actual numbers.  See RFC4181 Section 4.5 for an example of how
   this is done in a draft MIB module.

10.  Acknowledgements

   The authors wish to thank Thomas Clausen, Justin Dean, and Adrian
   Farrel for their detailed reviews and insightful comments to this
   document.

   This MIB document uses the template authored by D. Harrington which
   is based on contributions from the MIB Doctors, especially Juergen
   Schoenwaelder, Dave Perkins, C.M.Heard and Randy Presuhn.

11.  References

11.1.  Normative References

   [RFC2119]     Bradner, S., "Key words for use in RFCs to Indicate
                 Requirement Levels", BCP 14, RFC 2119, March 1997.

Herberg, et al.         Expires December 3, 2012               [Page 61]
Internet-Draft                The NHDP-MIB                     June 2012

   [RFC2578]     McCloghrie, K., Ed., Perkins, D., Ed., and J.
                 Schoenwaelder, Ed., "Structure of Management
                 Information Version 2 (SMIv2)", STD 58, RFC 2578,
                 April 1999.

   [RFC2579]     McCloghrie, K., Ed., Perkins, D., Ed., and J.
                 Schoenwaelder, Ed., "Textual Conventions for SMIv2",
                 STD 58, RFC 2579, April 1999.

   [RFC2580]     McCloghrie, K., Perkins, D., and J. Schoenwaelder,
                 "Conformance Statements for SMIv2", STD 58, RFC 2580,
                 April 1999.

   [RFC2863]     McCloghrie, K. and F. Kastenholz, "The Interfaces Group
                 MIB", RFC 2863, June 2000.

   [RFC3418]     Presuhn, R., "Management Information Base (MIB) for the
                 Simple Network Management Protocol (SNMP)", STD 62,
                 RFC 3418, December 2002.

   [RFC4001]     Daniele, M., Haberman, B., Routhier, S., and J.
                 Schoenwaelder, "Textual Conventions for Internet
                 Network Addresses", RFC 4001, February 2005.

   [RFC6130]     Clausen, T., Dearlove, C., and J. Dean, "Mobile Ad Hoc
                 Network (MANET) Neighborhood Discovery Protocol
                 (NHDP)", RFC 6130, April 2011.

   [RFC6340]     Presuhn, R., "Textual Conventions for the
                 Representation of Floating-Point Numbers", RFC 6340,
                 August 2011.

11.2.  Informative References

   [RFC3410]     Case, J., Mundy, R., Partain, D., and B. Stewart,
                 "Introduction and Applicability Statements for
                 Internet-Standard Management Framework", RFC 3410,
                 December 2002.

   [RFC3414]     Blumenthal, U. and B. Wijnen, "User-based Security
                 Model (USM) for version 3 of the Simple Network
                 Management Protocol (SNMPv3)", STD 62, RFC 3414,
                 December 2002.

   [RFC3826]     Blumenthal, U., Maino, F., and K. McCloghrie, "The
                 Advanced Encryption Standard (AES) Cipher Algorithm in
                 the SNMP User-based Security Model", RFC 3826,
                 June 2004.

Herberg, et al.         Expires December 3, 2012               [Page 62]
Internet-Draft                The NHDP-MIB                     June 2012

   [RFC4750]     Joyal, D., Galecki, P., Giacalone, S., Coltun, R., and
                 F. Baker, "OSPF Version 2 Management Information Base",
                 RFC 4750, December 2006.

   [RFC5148]     Clausen, T., Dearlove, C., and B. Adamson, "Jitter
                 Considerations in Mobile Ad Hoc Networks (MANETs)",
                 RFC 5148, February 2008.

   [RFC5591]     Harrington, D. and W. Hardaker, "Transport Security
                 Model for the Simple Network Management Protocol
                 (SNMP)", RFC 5591, June 2009.

   [RFC5592]     Harrington, D., Salowey, J., and W. Hardaker, "Secure
                 Shell Transport Model for the Simple Network Management
                 Protocol (SNMP)", RFC 5592, June 2009.

   [RFC6353]     Hardaker, W., "Transport Layer Security (TLS) Transport
                 Model for the Simple Network Management Protocol
                 (SNMP)", RFC 6353, July 2011.

   [REPORT-MIB]  Cole, R., Macker, J., and A. Bierman, "Definition of
                 Managed Objects for Performance Reporting", work in
                 progress draft-ietf-manet-report-mib-02, January 2012.

Appendix A.

   ***************************************************************
   * Note to the RFC Editor (to be removed prior to publication) *
   *                                                             *
   * The reference to RFCXXXX within the DESCRIPTION clauses     *
   * of the MIB module point to this draft and are to be         *
   * assigned by the RFC Editor.                                 *
   *                                                             *
   ***************************************************************

Why is "Appendix A" as a section necessary?  Are you telling the RFC editor to remove the  section and also modify the table of contents? Its just easier to discard the section now.

Authors' Addresses

   Ulrich Herberg
   LIX, Ecole Polytechnique
   Palaiseau Cedex,   91128
   France

   EMail: [email-masked]
   URI:   http://www.herberg.name/

Herberg, et al.         Expires December 3, 2012               [Page 63]
Internet-Draft                The NHDP-MIB                     June 2012

   Robert G. Cole
   US Army CERDEC
   6010 Frankford Road, Bldg 6010
   Aberdeen Proving Ground, Maryland  21005
   USA

   Phone: +1 443 395 8744
   EMail: [email-masked]
   URI:   http://www.cs.jhu.edu/~rgcole/

   Ian D Chakeres
   CenGen
   9250 Bendix Road North
   Columbia, Maryland  560093
   USA

   EMail: [email-masked]
   URI:   http://www.ianchak.com/

Herberg, et al.         Expires December 3, 2012               [Page 64]
<

From: Adrian Farrel <[email-masked]<mailto:[email-masked]>>
Reply-To: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>
To: 'Ulrich Herberg' <[email-masked]<mailto:[email-masked]>>, "'Bert Wijnen (IETF)'" <[email-masked]<mailto:[email-masked]>>
Cc: "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "[email-masked]<mailto:[email-masked]>" <[email-masked]<mailto:[email-masked]>>, "'MIB Doctors (E-mail)'" <[email-masked]<mailto:[email-masked]>>
Subject: Re: [MIB-DOCTORS] Heads-up MIB review impending

Ulrich,

just in case you are no aware of http://www.ibr.cs.tu-bs.de/projects/libsmi/tools/

Adrian

From: Ulrich Herberg [mailto:[email-masked]]
Sent: 22 May 2012 19:37
To: Bert Wijnen (IETF)
Cc: Benoit Claise; Adrian Farrel; [email-masked]<mailto:[email-masked]>; MIB Doctors (E-mail); [email-masked]<mailto:[email-masked]>
Subject: Re: [MIB-DOCTORS] Heads-up MIB review impending

Bert,
On Tue, May 22, 2012 at 11:33 AM, Bert Wijnen (IETF) <[email-masked]<mailto:[email-masked]>> wrote:
Unfortunately, there is not a free version (at least not current)
available as far as I know. I don;t understand why the author does not
just make it open source and available to everyone.
But that is his call I guess.

Okay, I see. My company will likely not pay for that, and personally I'd rather go to vacations than buy a MIB compiler ;-)

Oh by the way, you also already user { mib-2 998 } for the MIB OID!!!
that is not proper! You should use xxx or some such instead of 998
(as you indicate in the rfc-editor comment ;-)

I know, that has been discovered in the IESG LC. The reason why we did not put xxxx there is that smilint complains otherwise and fails to compile. It will be fixed in the next revision of the draft (or in the RFC editor queue).

Best
Ulrich

Bert

On 5/22/12 7:03 PM, Ulrich Herberg wrote:
Bert,

thank you very much for this first review. We will work on fixing these and spin a new version.

By the way, is there a free version of SMICng available? I only have smilint.

Best regards
Ulrich
On Tue, May 22, 2012 at 2:11 AM, Bert Wijnen (IETF) <[email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>> wrote:

   This is by no means a full MIB review, but I did a quick SMICng SYNTAX check:

   W: f(nhdp.mi2), (778,5) Row "nhdpLibRemovedIfAddrSetEntry" has indexing
        that  may create variables with more than 128 sub-ids
   W: f(nhdp.mi2), (1221,5) Row "nhdpIib2HopSetEntry" has indexing that may
        create variables with more than 128 sub-ids
   W: f(nhdp.mi2), (1117,16) Row "nhdpIibLinkSetEntry" does not have a
        consistent  indexing scheme - index item nhdpDiscIfIndex from base
        row nhdpDiscIfSetEntry  is not defined as an index item
   W: f(nhdp.mi2), (1376,15) Row "nhdpNibNeighborSetEntry" does not have a
        consistent indexing scheme - index item nhdpDiscRouterIndex from base
        row nhdpDiscIfSetEntry is not defined as an index item
   W: f(nhdp.mi2), (1425,16) Row "nhdpNibLostNeighborSetEntry" does not have
        a consistent indexing scheme - index item nhdpDiscRouterIndex from base
        row nhdpDiscIfSetEntry is not defined as an index item
   W: f(nhdp.mi2), (1614,16) Row "nhdpDiscIfSetPerfEntry" does not have a
        consistent indexing scheme - index item nhdpDiscIfIndex from base row
        nhdpDiscIfSetEntry is not defined as an index item
   W: f(nhdp.mi2), (1690,16) Row "nhdpDiscNeighborSetPerfEntry" does not
        have a consistent indexing scheme - index item nhdpDiscRouterIndex from
        base row nhdpDiscIfSetEntry is not defined as an index item
   W: f(nhdp.mi2), (1768,16) Row "nhdpIib2HopSetPerfEntry" does not have a
        consistent indexing scheme - index item nhdpDiscRouterIndex from base
        row nhdpDiscIfSetEntry is not defined as an index item
   W: f(nhdp.mi2), (1941,21) Variable "nhdpIfIndex" in notification
   "nhdpNbrStateChange" is an index for a table
   W: f(nhdp.mi2), (1956,21) Variable "nhdpIfIndex" in notification
   "nhdp2HopNbrStateChange" is an index for a table
   W: f(nhdp.mi2), (1973,21) Variable "nhdpIfIndex" in notification
   "nhdpIfRxBadPacket" is anindex for a table
   W: f(nhdp.mi2), (1992,21) Variable "nhdpIfIndex" in notification
   "nhdpIfStateChange" is anindex for a table
   W: f(nhdp.mi2), (2142,22) Duplicate item "nhdpPerformanceGroup"
        in MANDATORY-GROUPS for module "NHDP-MIB"

   The first  Warning got me to look at:
      nhdpLibRemovedIfAddrSetEntry  OBJECT-TYPE
         SYNTAX      NhdpLibRemovedIfAddrSetEntry
         MAX-ACCESS  not-accessible
         STATUS      current
         DESCRIPTION
   "A router's Removed Interface Address Set consists
            of Removed Interface Address Tuples, one per network
            address:

            (IR_local_iface_addr, IR_time)

            The association between these addrs and
            the router's Interface is found in the

            Standard MIB II's IP address table
            (RFC1213)."
         REFERENCE
   "RFC6130."
         INDEX { nhdpLibRemovedIfAddrSetIpAddrT__ype,

                 nhdpLibRemovedIfAddrSetIpAddr }
      ::= { nhdpLibRemovedIfAddrSetTable 1 }

      NhdpLibRemovedIfAddrSetEntry ::=
         SEQUENCE {
            nhdpLibRemovedIfAddrSetIpAddrT__ype
              InetAddressType,
            nhdpLibRemovedIfAddrSetIpAddr
              InetAddress,
            nhdpLibRemovedIfAddrSetIpAddrP__refixLen

              InetAddressPrefixLength,
            nhdpLibRemovedIfAddrSetIfIndex
              InterfaceIndexOrZero,
            nhdpLibRemovedIfAddrSetIRTime
              TimeStamp
           }
     nhdpLibRemovedIfAddrSetIpAddrT__ype  OBJECT-TYPE

        SYNTAX      InetAddressType
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION
   "The type of the nhdpLibRemovedIfAddrSetIpAddr
            in the InetAddress MIB (RFC4001).

            Only the values ipv4(1) and
            ipv6(2) are supported."
        REFERENCE
   "RFC6130."
     ::= { nhdpLibRemovedIfAddrSetEntry 1 }

     nhdpLibRemovedIfAddrSetIpAddr  OBJECT-TYPE
        SYNTAX      InetAddress
        MAX-ACCESS  read-only
        STATUS      current
        DESCRIPTION
   "nhdpLibRemovedIfAddrSetIpAddr is a
            recently used address of an interface of
            this router."
        REFERENCE
   "RFC6130."
     ::= { nhdpLibRemovedIfAddrSetEntry 2 }

   And I note that:

   - the 2 INDEX obbjects are defined read-only. Normally they would be
     not-accessible!!! See RFC2578
   - If this is ALWAYS true:
       nhdpLibRemovedIfAddrSetIpAddrT__ype  OBJECT-TYPE

          SYNTAX      InetAddressType
          MAX-ACCESS  read-only
          STATUS      current
          DESCRIPTION
   "The type of the nhdpLibRemovedIfAddrSetIpAddr
            in the InetAddress MIB (RFC4001).

            Only the values ipv4(1) and
            ipv6(2) are supported."
     Then you could do:
       nhdpLibRemovedIfAddrSetIpAddr  OBJECT-TYPE
          SYNTAX      InetAddress (SIZE(4|16))
          MAX-ACCESS  read-only
     Otherwise you would have to add something to description clause to
     warn implementers that they should consider OID size.

   The third warning:
     W: f(nhdp.mi2), (1117,16) Row "nhdpIibLinkSetEntry" does not have a
          consistent  indexing scheme - index item nhdpDiscIfIndex from base
          row nhdpDiscIfSetEntry  is not defined as an index item
   Seems a valid warning. But I am not 100% sure. I'd have to go and study
   more detauil to determine.
   Anyways, these "inconsistent indexing" warnings are indeed just
   warnings. It may be OK, but it would be good to check and make sure
   that this results in proper (i.e. unique) indexing values and that the
   indexing is indeed as intended.

   Sorry, not enough time to check more details now.

   Bert
   ----- Original Message ----- From: "Benoit Claise" <[email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>>

   To: <[email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>>
   Cc: <[email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>>; <[email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>>;
   <[email-masked]<http://tools.ietf.org> <mailto:[email-masked]<mailto:[email-masked]>>>

   Sent: Tuesday, May 22, 2012 12:15 AM

   Subject: Re: [MIB-DOCTORS] Heads-up MIB review impending

       Dear all,

       I have deferred this draft for the next telechat.

       Regards, Benoit.

           Hi MIB doctors,

           We would really benefit from your expertise here.
           Can we please have a volunteer.
           If we don't find someone by the end of the day (on telechat for this
           Thursday), I'm afraid that I will have to defer this draft to the next
           telechat...

           Regards, Benoit.

               Hi MIB doctors,

               My bad for not following up on this one. I will follow more closely from now
               on.
               Can we please have a volunteer to review this MIB module, which is on the
               IESG telechat for next Thursday.

               Regards, Benoit.

                   Hi MIB Doctors,

                   Heads up to give you extra review time.
                   https://datatracker.ietf.org/__doc/draft-ietf-manet-nhdp-mib/

                   <https://datatracker.ietf.org/doc/draft-ietf-manet-nhdp-mib/> is going to
                   IETF
                   last call very soon and would benefit significantly from a MIB Doctor
                   review by
                   the end of the last call.

                   Thanks for the work you do.

                   Adrian
                   _________________________________________________
                   MIB-DOCTORS mailing list
                   [email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>
                   https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>

               _________________________________________________
               MIB-DOCTORS mailing list
               [email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>
               https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>

           _________________________________________________
           MIB-DOCTORS mailing list
           [email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>
           https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>

       _________________________________________________
       MIB-DOCTORS mailing list
       [email-masked]<mailto:[email-masked]> <mailto:[email-masked]<mailto:[email-masked]>>
       https://www.ietf.org/mailman/__listinfo/mib-doctors <https://www.ietf.org/mailman/listinfo/mib-doctors>

---

From: Thomas Nadeau <[email-masked]>
Date: Thu, 7 Jun 2012 07:45:24 -0400

glad to help. please let me know of you have any questions or want to walk through any needed changes.

Tom

On Jun 6, 2012, at 10:03 PM, "Ulrich Herberg" <[email-masked]> wrote:

> Thomas, Benoit,
>
> thank you very much for the reviews. This is extremely valuable for
> us, and we will work on addressing all your concerns in a new revision
> in the following days. Since this is the first of several MIB
> documents in the MANET WG, we want to get this one right, so the
> following ones will be a piece of cake.
>
> Best regards
> Ulrich and Bob
>
> On Wed, Jun 6, 2012 at 6:22 PM, Thomas Nadeau <[email-masked]> wrote:
>>
>> Hi all,
>>